
package fr.inria.infovis.column;


/**
 *
 * A new Dynamic IntVector with an insert method.
 * Standard IntVector of INFOVIS ToolKit does not support
 * the feature 
 * 
 */


public class IntVector extends infovis.utils.IntVector {

	
	
	/**
	 * Insert a new element at the given position into the Dynamic int Array
	 * - ensure the capacity of the array if necessary
	 * - shift to the right all the element from <code>index</code> of one position
	 * - set the inserted <code>value</code> at <code>index</code>
	 * @param index  the position where the element must be inserted
	 * @param value  the element to insert int the dynamic array
	 */
	public void insertAt(int index, int value) {
		int current = size();
		reserve(current+1);
		if (index == current) {
			set(index+1, get(index));
			set(index, value);
		}  else if (index < current) {
			int[] data = getData();
			System.arraycopy(data, index, data, index+1, current - index);
			set(index,value);
		} 
		
	}
	
}
