/*
 * Created on 11 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.infovis.column;

import infovis.Column;


/**
 * 
 * extends the Column interface of infovis to handle layers.
 * Layers introduce the multi dimensional columns.
 * LayeredColumn must be view as a <b>Decorator</b> of standard 
 * columns
 * 
 */
public interface LayeredColumn extends Column {
	
	/**
	 * 
	 * Restore the values of the column
	 * using layers range <code>[from,to]</code> 
	 * @param from first layer used
	 * @param to last layer used
	 */
	public void restoreLayers(int from, int to);
	
	/**
	 * 
	 * give the "decored" column, i.e. the real column 
	 * to which the layer mechanism has been externally added
	 *  
	 * @return a decored column
	 */
	public Column getColumn();
	
	/**
	 * set the "decored" column, i.e. the real column 
	 * to which the layer mechanism has been externally added
	 * @param c the decored column
	 */
	public void setColumn(Column c);
}
