package fr.inria.infovis.panel;

import infovis.Visualization;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;
import javax.swing.event.*;


/**
 * @author raf
 *
 * A replacement of the AbstractControlPanel of Infovis
 * 
 * 
 */
public abstract class AbstractControlPanel extends Box
    implements ListDataListener, ActionListener, ChangeListener {
    private Visualization visualization;
    Dimension    maxSliderDimension = new Dimension(Integer.MAX_VALUE, 40);

    /**
     * Constructor for AbstractControlPanel.
     * @param vis the visualization to control
     */
    public AbstractControlPanel(Visualization vis) {
        super(BoxLayout.Y_AXIS);
        this.visualization = vis;
    }
    
    /**
     * Creates a title border around a specified component
     * @param comp the JComponent to decorate
     * @param title the title
     */
    public void setTitleBorder(JComponent comp, String title) {
        comp.setBorder(BorderFactory.createTitledBorder(title));
    }
    
    /**
     * Sets the maximum size of a specified component (slider like)
     * @param rs the component
     */
    public void setMaximumSize(JComponent rs) {
        rs.setMaximumSize(maxSliderDimension);
    }

    /**
     * @see javax.swing.event.ListDataListener#contentsChanged(ListDataEvent)
     */
    public void contentsChanged(ListDataEvent e) {
    }

    /**
     * @see javax.swing.event.ListDataListener#intervalAdded(ListDataEvent)
     */
    public void intervalAdded(ListDataEvent e) {
    }

    /**
     * @see javax.swing.event.ListDataListener#intervalRemoved(ListDataEvent)
     */
    public void intervalRemoved(ListDataEvent e) {
    }
    
    /**
     * @see java.awt.event.ActionListener#actionPerformed(ActionEvent)
     */
    public void actionPerformed(ActionEvent e) {
    }

    /**
     * @see javax.swing.event.ChangeListener#stateChanged(ChangeEvent)
     */
    public void stateChanged(ChangeEvent e) {
    }

    /**
     * Returns the visualization.
     * @return the Visualization
     */
    public Visualization getVisualization() {
        return visualization;
    }

    public void dispose() {};
}
