

package fr.inria.infovis.panel;

import infovis.Table;

import javax.swing.AbstractListModel;
import javax.swing.ComboBoxModel;

/**
 * @author raf
 *
 * A replacement of the ColumnListModel of Infovis
 * 
 * 
 */
public class ColumnListModel extends AbstractListModel
    implements ComboBoxModel {
    Table table;
    Object selectedObject;
    boolean nullAdded;

    /**
     * Constructor for ColumnListModel.
     */
    public ColumnListModel(Table table) {
	this.table = table;
    }

    /**
     * @see javax.swing.ListModel#getElementAt(int)
     */
    public Object getElementAt(int index) {
	return table.getColumnAt(index);
    }

    /**
     * @see javax.swing.ListModel#getSize()
     */
    public int getSize() {
	return table.getColumnCount() + (nullAdded ? 1 : 0);
    }

    // implements javax.swing.ComboBoxModel
    /**
     * Sets the value of the selected item. The selected item may be null.
     * <p>
     * @param anObject The combo box value or null for no selection.
     */
    public void setSelectedItem(Object anObject) {
        if ((selectedObject != null && !selectedObject.equals( anObject )) ||
	    selectedObject == null && anObject != null) {
	    selectedObject = anObject;
	    fireContentsChanged(this, -1, -1);
        }
    }

    // implements javax.swing.ComboBoxModel
    public Object getSelectedItem() {
        return selectedObject;
    }
    /**
     * Returns the table.
     * @return Table
     */
    public Table getTable() {
        return table;
    }

    /**
     * Returns the nullAdded.
     * @return boolean
     */
    public boolean isNullAdded() {
        return nullAdded;
    }

    /**
     * Sets the nullAdded.
     * @param nullAdded The nullAdded to set
     */
    public void setNullAdded(boolean nullAdded) {
        if (this.nullAdded != nullAdded) {
            this.nullAdded = nullAdded;
            fireContentsChanged(this, -1, -1);
        }
    }

}
