package fr.inria.infovis.panel.visualization;

import infovis.Tree;
import infovis.column.ColumnFilter;
import infovis.panel.DynamicQueryPanel;
import infovis.tree.visualization.TreeStructrureFilter;
import infovis.tree.visualization.TreeVisualPanel;
import infovis.tree.visualization.TreeVisualization;

import javax.swing.JComponent;

import fr.inria.infovis.panel.DefaultControlPanel;


/**
 * @author raf
 *
 * A replacement of the ScatterPlotControlPanel of Infovis
 * 
 * 
 */
public class TreeControlPanel extends DefaultControlPanel {
    protected DynamicQueryPanel treeQueryPanel;

    /**
     * Constructor for TreeControlPanel.
     * 
     * @param visualization the visualization.
     */
    public TreeControlPanel(TreeVisualization visualization) {
        this(visualization, TreeStructrureFilter.sharedInstance());
    }
    
    /**
     * Constructor for TreeControlPanel.
     * 
     * @param visualization the visualization.
     * @param filter the ColumnFilter.
     */
    public TreeControlPanel(TreeVisualization visualization, ColumnFilter filter) {
        super(visualization, filter);
    }
    
    /**
     * Returns the managed tree visualization.
     * 
     * @return the managed tree visualization.
     */
    public TreeVisualization getTreeVisualization() {
        return (TreeVisualization)getVisualization()
            .findVisualization(TreeVisualization.class);
    }

    /**
     * Returns the managed tree.
     *
     * @return the managed tree.
     */
    public Tree getTree() {
        return getTreeVisualization().getTree();
    }

    /**
     * @see infovis.panel.ControlPanel#createStdVisualPane()
     */
    protected JComponent createVisualPanel() {
        JComponent ret = new TreeVisualPanel(getVisualization(), getFilter());
        return ret;
    }

}
