/*
 * Created on 28 avr. 2004
 *
 */
package fr.inria.oadymppac.examples;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import fr.inria.oadymppac.utils.IntIntervalArray;

/**
 * 
 * a demo program to test the behaviour of the domain
 * 
 * 
 * @author raf
 *
 */
public class DomainDemo {
	/**
	 * <code>NONE</code> the none value, means undefined value
	 */
	public static final int NONE=IntIntervalArray.NONE;
	/**
	 * <code>PROMPT</code> the comand line default prompt
	 */
	public static final String PROMPT="ENTER A NEW COMMAND>";
	
	/**
	 * <code>domain</code> the domain used for the demo
	 */
	protected IntIntervalArray domain;
	
	/**
	 * the default Constructor
	 */
	public DomainDemo() {
		domain = new IntIntervalArray();
	}
	
	/**
	 * 
	 * Lauch the demo
	 * 
	 * @param args command line arguments
	 */
	public static void main(String[] args) {
		DomainDemo example = new DomainDemo();
		example.start();
	}
	
	
	/**
	 * start the demo, basiccaly enter in the command loop
	 */
	public void start() {
		String command=new String();
		String token=null;
		String buffer=null;
		int from, to;
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer tokenizer = null;
		while(!command.equals("q")) {
			System.out.print(PROMPT);
			command=null;
			token=null;
			from=NONE;
			to=NONE;
			
				try {
					buffer= console.readLine();	
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (buffer != null) {
					tokenizer = new StringTokenizer(buffer);
					command = tokenizer.hasMoreTokens() ?  tokenizer.nextToken() : null;
					token = tokenizer.hasMoreTokens() ?  tokenizer.nextToken() : null;
					from = (token == null ? NONE : Integer.parseInt(token));
					token = tokenizer.hasMoreTokens() ? tokenizer.nextToken() : null;
					to = (token == null ? from : Integer.parseInt(token));
					interpret(command, from, to);
				}
		}
		System.out.println("Bye!");
	}
	
	/**
	 * 
	 * Interpret the command entered by the user
	 * 
	 * @param command the command
	 * @param from the first argument
	 * @param to the second argument
	 */
	protected void interpret(String command, int from, int to) {
		if (command.equals("a") && from != NONE && to !=NONE) {
			domain.add(from,to);
			System.out.println(domain);
		} else if (command.equals("r") && from != NONE && to !=NONE) {
			domain.remove(from,to);
			System.out.println(domain);
		} else if (command.equals("s") ) {
			System.out.println(domain);
		} else if (command.equals("c") ) {
			domain.clear();	
			System.out.println(domain);
		} else if (command.equals("n") ) {
			domain = new IntIntervalArray();	
		} else if (command.equals("q") ) {
			System.out.println("Quit...");
		} else if (command.equals("h") ) {
			System.out.println("HELP:");
			System.out.println("a <from> <to> \t:add a new interval to the domain");
			System.out.println("r <from> <to> \t:remove a new interval to the domain");
			System.out.println("s \t\t:show the current domain");
			System.out.println("c \t\t:clear the current domain");
			System.out.println("n \t\t:create a new domain instance");
			System.out.println("h \t\t:display this message");
		} else {
			System.out.println("INVALID COMMAND !");
		}
	}
}
