/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 17 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.examples.parsingfaster;

import java.util.Iterator;
import java.util.Vector;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventListenerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.ExplanationReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.BackToEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.FailureEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RejectEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEvent;
import fr.inria.oadymppac.parsing.info.AnnotationCommandInfo;
import fr.inria.oadymppac.parsing.info.AnnotationInfo;
import fr.inria.oadymppac.parsing.info.BasicInfo;
import fr.inria.oadymppac.parsing.info.CauseInfo;
import fr.inria.oadymppac.parsing.info.CauseListInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListProvider;
import fr.inria.oadymppac.parsing.info.ChoicePointInfo;
import fr.inria.oadymppac.parsing.info.ConstraintInfo;
import fr.inria.oadymppac.parsing.info.ConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ConstraintsInfo;
import fr.inria.oadymppac.parsing.info.DeltaInfo;
import fr.inria.oadymppac.parsing.info.DeltaListInfo;
import fr.inria.oadymppac.parsing.info.DeltaListProvider;
import fr.inria.oadymppac.parsing.info.DeltaProvider;
import fr.inria.oadymppac.parsing.info.ExplanationInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListInfo;
import fr.inria.oadymppac.parsing.info.NewStageInfo;
import fr.inria.oadymppac.parsing.info.StageCommentInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateMiscInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.UpdateInfo;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.UpdateListProvider;
import fr.inria.oadymppac.parsing.info.UpdateProvider;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.ValueListProvider;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.parsing.info.VarDomainProvider;
import fr.inria.oadymppac.parsing.info.VariableInfo;
import fr.inria.oadymppac.parsing.info.VariableListInfo;

/**
 * @author raf
 *  @
 */
public class SingleSolverEventListener extends EventListenerImpl implements
        NewVariableEventListener, NewConstraintEventListener, PostEventListener {

	protected static final boolean display = true;
	protected static final boolean store = false;
	protected static final boolean garbage = false;
	protected static final int     DEFAULT_GARBAGE_PERIOD=1;
	protected int garbage_count;
	protected int garbage_period;
	
    Vector buffer = new Vector();
    


    protected void add(Object o) {
        if (store) buffer.add(o);
    }

    
    
    
    public void eventProcess(NewVariableEvent ev) {
    	if (display) {
        System.out
                .println("------------------ NEW VARIABLE EVENT!!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NAME:" + ev.getName());
        System.out.println("INTERNAL:" + ev.getInternal());
        System.out.println("EXTERNAL:" + ev.getExternal());
        showValueList(ev);
        showVarDomain(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(NewConstraintEvent ev) {
    	if (display) {
        System.out
                .println("------------------ NEW CONSTRAINT EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NAME:" + ev.getName());
        System.out.println("INTERNAL:" + ev.getInternal());
        System.out.println("EXTERNAL:" + ev.getExternal());
        showUpdates(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(PostEvent ev) {
    	if (display) {
      System.out
                .println("------------------ POST EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(ChoicePointEvent ev) {
    	if (display) {
        System.out
                .println("------------------ CHOICE POINT EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NODE:" + ev.getNode());
        ChoiceConstraintListProvider choicConstraintList = (ChoiceConstraintListProvider) ev;
        
        
        showChoiceConstraints(ev);
        showState(ev);
        try {
            //ChoicePointInfo info = (ChoicePointInfo) ev.getInfo();
            BasicInfo info = (BasicInfo) ev.getInfo();
            add(info.clone());
        } catch (CloneNotSupportedException excp) {
            // TODO Auto-generated catch block
            excp.printStackTrace();
        }
    	}
    	garbage();
        
    }

    public void eventProcess(SolutionEvent ev) {
    	if (display) {
        System.out
                .println("------------------ SOLUTION EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NODE:" + ev.getNode());
        System.out.println("NODENAME:" + ev.getNodeName());
        System.out.println("SOLUTION VALUE:" + ev.getValue());
        showChoiceConstraints(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(FailureEvent ev) {
    	if (display) {
        System.out
                .println("------------------ FAILURE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NODE:" + ev.getNode());
        System.out.println("NODENAME:" + ev.getNodeName());
        showChoiceConstraints(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(BackToEvent ev) {
    	if (display) {
        System.out
                .println("------------------ BACK TO EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NODE:" + ev.getNode());
        System.out.println("NODE BEFORE:" + ev.getNodeBefore());
        showDeltas(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(ReduceEvent ev) {
    	if (display) {
        System.out
                .println("------------------ REDUCE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("VARIABLE:" + ev.getVariable());
        showVarDomain(ev);
        showDelta(ev);
        showUpdate(ev);
        if (ev instanceof ExplanationReduceEvent) {
        	showExplanations((ExplanationReduceEvent) ev);
        }
    	}
    	garbage();
    }

    public void eventProcess(AwakeEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ AWAKE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showUpdate(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(ScheduleEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ SCHEDULE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showScheduleActions(ev.getActions());
        showUpdate(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(RemoveEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ REMOVE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(RestoreEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ RESTORE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("VARIABLE:" + ev.getVariable());
        showDeltas(ev);
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(SuspendEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ SUSPEND EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showState(ev);
    	}
    	garbage();
   }

    public void eventProcess(SolvedEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ SOLVED EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showState(ev);
    	}
    	garbage();
    }

    public void eventProcess(RejectEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ REJECT EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("CONSTRAINT:" + ev.getConstraint());
        showState(ev);

    	}
    	garbage();
    }

    public void eventProcess(AnnotationEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ ANNOTATION EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("ANNOTATION:" + ev.getIdentifier());
        AnnotationInfo annotation;
        AnnotationCommandInfo annotationInfo;
        try {
            annotation = (AnnotationInfo) ev.getInfo();
            annotationInfo = (AnnotationCommandInfo) annotation.getCommand();
            if (annotationInfo != null)
                System.out.println("COMMAND:" + annotationInfo.getCommand());
            else
                System.out.println("NO COMMAND PROVIDED");
        } catch (CloneNotSupportedException excp) {
            excp.printStackTrace();
        }
    	}
    	garbage();
    }

    public void eventProcess(NewStageEvent ev) {
    	if (display) {System.out
                .println("------------------ NEW STAGE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("NEW STAGE:" + ev.getIdentifier());
        System.out.println("DETAIL:" + ev.getDetail());
        showStageReferences(ev.getReferences());
        NewStageInfo newstage;
        StageCommentInfo stageCommentInfo;
        try {
            newstage = (NewStageInfo) ev.getInfo();
            stageCommentInfo = (StageCommentInfo) newstage.getComment();
            if (stageCommentInfo != null)
                System.out.println("COMMENT:" + stageCommentInfo.getComment());
            else
                System.out.println("NO COMMAND PROVIDED");
        } catch (CloneNotSupportedException excp) {
            excp.printStackTrace();
        }
    	}
    	garbage();

    }
    
    public void eventProcess(StartStageEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ START STAGE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("STAGE:" + ev.getStage());
    	}
    	garbage();
    }
    
    
    public void eventProcess(SuspendStageEvent ev) {
    	if (display) {
        System.out
                .println("------------------ SUSPEND STAGE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("STAGE:" + ev.getStage());
    	}
    	garbage();
    }
    
    public void eventProcess(ResumeStageEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ RESUME STAGE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("STAGE:" + ev.getStage());
    	}
    	garbage();
    }
    
    public void eventProcess(EndStageEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ END STAGE EVENT !!! ------------------");
        System.out.println("CHRONO:" + ev.getChrono());
        System.out.println("DEPTH:" + ev.getDepth());
        System.out.println("STAGE:" + ev.getStage());
    	}
    	garbage();
    }
    
    
    
    
    public void eventProcess(StateEvent ev) {
    	if (display) {
    	System.out
                .println("------------------ COMPLEMENT STATE EVENT !!! ------------------");
        StateInfo info = null;
        try {
            info = (StateInfo) ev.getInfo();
        } catch (CloneNotSupportedException excp) {
            logger.error("State Doesnot containt info", excp);
        }
        if (info != null) showState(info);
    	}
    	garbage();
    }

    protected void showValueList(Event ev) {
        ValueListProvider valueList = (ValueListProvider) ev;
        showValueList(valueList.getValueList());
    }

    protected void showValueList(ValueListInfo dom) {
        Iterator it = (dom == null ? null : dom.iterator());
        System.out.print("VALUE LIST:< ");
        while (it != null && it.hasNext())
            System.out.print((it.next()).toString() + " ");
        System.out.println(" >");
    }

    protected void showChoiceConstraints(Event ev) {
        ChoiceConstraintListProvider choicConstraintList = (ChoiceConstraintListProvider) ev;
        ChoiceConstraintListInfo choicConstraints = choicConstraintList
                .getChoiceConstraintList();
        if (choicConstraints != null) showChoiceConstraints(choicConstraints);
    }

    protected void showChoiceConstraints(
            ChoiceConstraintListInfo choicConstraints) {
        ChoiceConstraintInfo info;
        Iterator it = (choicConstraints == null ? null : choicConstraints
                .iterator());
        System.out.println("CHOICE CONSTRAINTS:< ");
        while (it != null && it.hasNext()) {
            info = (ChoiceConstraintInfo) it.next();
            System.out.println("\tVARIABLE:" + info.getVariable());
            System.out.println("\tVALUE:" + info.getValue());
        }
        System.out.println(" >");
    }

    protected void showDeltas(Event ev) {
        DeltaListProvider deltaList = (DeltaListProvider) ev;
        DeltaListInfo deltas = deltaList.getDeltaList();
        DeltaInfo info;
        Iterator it = (deltas == null ? null : deltas.iterator());
        System.out.println("UPDATES:< ");
        while (it != null && it.hasNext()) {
            info = (DeltaInfo) it.next();
            showDelta(info);
        }
        System.out.println(" >");
    }

    protected void showUpdates(Event ev) {
        UpdateListProvider updateList = (UpdateListProvider) ev;
        UpdateListInfo updates = updateList.getUpdateList();
        if (updates != null) showUpdates(updates);
    }

    protected void showUpdates(UpdateListInfo updates) {
        UpdateInfo info;
        Iterator it = (updates == null ? null : updates.iterator());
        System.out.println("UPDATES:< ");
        while (it != null && it.hasNext()) {
            info = (UpdateInfo) it.next();
            showUpdate(info);
        }
        System.out.println(" >");
    }

    protected void showUpdate(Event ev) {
        UpdateProvider update = (UpdateProvider) ev;
        UpdateInfo info = update.getUpdate();
        if (info != null) showUpdate(info);
    }

    protected void showUpdate(UpdateInfo info) {
        System.out.println("UPDATE VARIABLE:" + info.getVariable());
        showUpdateTypes(info.getType());
        ValueListInfo valueList = info.getValueList();
        if (valueList != null)
            showValueList(valueList);
        else
            System.out.println("No values provided for update");
    }

    protected void showVarDomain(Event ev) {
        VarDomainProvider vardomain = (VarDomainProvider) ev;
        VarDomainInfo info = vardomain.getVarDomain();
        if (info != null) showVarDomain(info);
    }

    protected void showVarDomain(VarDomainInfo info) {
        System.out.println("\tVARIABLE DOMAIN:");
        System.out.println("\t\tMIN:" + info.getMin());
        System.out.println("\t\tMAX:" + info.getMax());
        System.out.println("\t\tSIZE:" + info.getSize());
        ValueListInfo valueList = info.getValueList();
        if (valueList != null) {
        	System.out.println("\t\t");
            showValueList(valueList);
        } else
            System.out.println("No values provided for update");
    }

    protected void showDelta(Event ev) {
        DeltaProvider vardomain = (DeltaProvider) ev;
        DeltaInfo info = vardomain.getDelta();
        if (info != null) showDelta(info);
    }

    protected void showDelta(DeltaInfo info) {
        System.out.println("DELTA DOMAIN:" + info.getVariable());
        ValueListInfo valueList = info.getValueList();
        if (valueList != null)
            showValueList(valueList);
        else
            System.out.println("No values provided for update");
    }

    protected void showUpdateTypes(short[] types) {
        System.out.print("\tTYPES: < ");
        if (types != null && types.length > 0) {
            for (int i = 0; i < types.length - 1; i++)
                System.out.print("" + types[i] + ",");
            System.out.println("" + types[types.length - 1] + " >");
        } else {
            System.out.println(" >");
        }
    }

    protected void showScheduleActions(String[] actions) {
        System.out.print("\tACTIONS: < ");
        if (actions != null && actions.length > 0) {
            for (int i = 0; i < actions.length - 1; i++)
                System.out.print(actions[i] + ",");
            System.out.println("" + actions[actions.length - 1] + " >");
        } else {
            System.out.println(" >");
        }
    }
    
    
    protected void showStageReferences(String[] references) {
        System.out.print("\tREFERENCES: < ");
        if (references != null && references.length > 0) {
            for (int i = 0; i < references.length - 1; i++)
                System.out.print(references[i] + ",");
            System.out.println("" + references[references.length - 1] + " >");
        } else {
            System.out.println(" >");
        }
    }

    protected void showState(Event ev) {
        StateProvider state = (StateProvider) ev;
        StateInfo info = state.getState();
        if (info != null) showState(info);
    }

    protected void showState(StateInfo info) {
        System.out.println("STATE:");
        System.out.println("\tCHRONO:" + info.getChrono());
        System.out.println("\tDEPTH:" + info.getDepth());
        System.out.println("\tCURRENT NODE:" + info.getCurrentNode());
        VariableListInfo variables = info.getVariableList();
        if (variables != null) {
            System.out.print("\t");
            showVariables(variables);
        }
        ConstraintListInfo constraints = info.getConstraintList();
        if (constraints != null) {
            System.out.print("\t");
            showContraintList(constraints);
        }
        UpdateListInfo updates = info.getUpdateList();
        if (updates != null) {
            System.out.print("\t");
            showUpdates(updates);
        }
        StateMiscInfo misc = info.getMisc();
        if (misc != null) System.out.println("\tMISC:" + misc.getMisc());
    }

    protected void showVariables(VariableListInfo variables) {
        VariableInfo info;
        Iterator it = (variables == null ? null : variables.iterator());
        System.out.println("STATE VARIABLES:< ");
        while (it != null && it.hasNext()) {
            info = (VariableInfo) it.next();
            System.out.print("\t");
            showVariable(info);
        }
        System.out.println(" >");
    }

    protected void showVariable(VariableInfo info) {
        System.out.println("\tSTATE VARIABLE:" + info.getIdentifier());
        System.out.println("\tNAME:" + info.getName());
        System.out.println("\tINTERNAL:" + info.getInternal());
        System.out.println("\tEXTERNAL:" + info.getExternal());
        ValueListInfo valueList = info.getValueList();
        if (valueList != null) {
            System.out.print("\t");
            showValueList(valueList);
        }
        VarDomainInfo varDomain = info.getVarDomain();
        if (varDomain != null) {
            System.out.print("\t");
            showVarDomain(varDomain);
        }
    }

    protected void showContraintList(ConstraintListInfo constraints) {
        ConstraintInfo info;
        Iterator it = (constraints == null ? null : constraints.iterator());
        System.out.println("STATE CONSTRAINTS:< ");
        while (it != null && it.hasNext()) {
            info = (ConstraintInfo) it.next();
            System.out.print("\t");
            showConstraint(info);
        }
        System.out.println(" >");
    }

    protected void showConstraint(ConstraintInfo info) {
        System.out.println("\tSTATE CONSTRAINT:" + info.getIdentifier());
        System.out.println("\tNAME:" + info.getName());
        System.out.println("\tINTERNAL:" + info.getInternal());
        System.out.println("\tEXTERNAL:" + info.getExternal());
        UpdateListInfo updateList = info.getUpdateList();
        if (updateList != null) {
            System.out.print("\t");
            showUpdates(updateList);
        }

    }

    
    protected void showExplanations(ExplanationReduceEvent ev) {
    	System.out.println("---------- SHOWING EXPLANATIONS  ---------------------");
    	ExplanationListInfo explanations = ev.getExplanationList();
    	Iterator it = (explanations == null ? null : explanations.iterator());
    	ExplanationInfo info;
        while (it != null && it.hasNext()) {
            info = (ExplanationInfo) it.next();
            System.out.println("EXPLANATION: " + info);
            System.out.print("\t");
            showValueList(info.getValueList());
            showConstraints(info.getConstraints());
            showCauseList(info.getCauseList());
        }
    }
    
    
    protected void showConstraints(ConstraintsInfo info) {
    	String[] references = (info==null ? null : info.getReferences());
        System.out.print("\tCONSTRAINTS REFERENCES: < ");
        if (references != null && references.length > 0) {
            for (int i = 0; i < references.length - 1; i++)
                System.out.print(references[i] + ",");
            System.out.println("" + references[references.length - 1] + " >");
        } else {
            System.out.println(" >");
        }
    }
    
    
    protected void showCauseList(CauseListInfo causes) {
        CauseInfo info;
        Iterator it = (causes == null ? null : causes.iterator());
        System.out.println("\tCAUSES:< ");
        int i=0;
        while (it != null && it.hasNext()) {
            info = (CauseInfo) it.next();
            System.out.println("\t\tCAUSE "+i++);
            System.out.println("\t\t\tVARIABLE:"+info.getVariable());
            System.out.println("\t\t\tTYPE:"+info.getType());
            System.out.print("\t\t\t");
            showValueList(info.getValueList());
        }
        System.out.println("\t >");
    }
    
    
    public void show() {
        System.out.println("---------- SHOWING STORED INFO  ---------------------");
        Iterator it = buffer.iterator();
        ChoicePointInfo info;
        while (it != null && it.hasNext()) {
            info = (ChoicePointInfo) it.next();
            System.out.println("STORED CHOICE-POINT: " + info);
            showChoiceConstraints(info.getChoiceConstraintList());
        }
    }
    protected void garbage() {
    	if ((garbage_count++ % (garbage_period ==0 ? DEFAULT_GARBAGE_PERIOD : garbage_period))==0 ) {
    		System.out.println("GARBAGING:"+garbage_count);
    		if (garbage) System.gc();
    	}
    }
}
