/*
 * Created on 30 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.panel;

import infovis.Column;
import infovis.Graph;
import infovis.Table;
import infovis.Visualization;
import infovis.column.ObjectColumn;
import infovis.graph.visualization.MatrixVisualization;
import infovis.utils.RowIterator;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.font.TextAttribute;
import java.awt.geom.Rectangle2D;
import java.util.Map;

import javax.swing.JLabel;
import javax.swing.SwingConstants;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class VisualizationHeaderDisplayer extends JLabel {
	public static final int DEFAULT_SIZE = 30;
	public static final int DEFAULT_LENGTH = 5;
	public static final Float DEFAULT_FONT_SIZE = new Float(10);
	
	public static final String DEFAULT_NAME="Label";
	
	
	/**
	 * Orientation of the component 
	 */
	protected int orientation;
	/**
	 * Matrix visualization attached to the componennt 
	 */
	protected MatrixVisualization visualization;
	/**
	 * Default height/width of the component;
	 */
	protected int defaultSize;
	
	/**
	 * Default length of the labels before truncature;
	 */
	protected int defaultLength;
	
	/**
	 * Default length of the labels before truncature;
	 */
	protected Float defaultFontSize;
	
	/**
	 * Name of the column containing the labal;
	 */
	protected String name;
	
	private ObjectColumn shapes;

	
	public VisualizationHeaderDisplayer(Visualization vis) {
		this(vis, DEFAULT_SIZE, SwingConstants.HORIZONTAL);
	}
	public VisualizationHeaderDisplayer(Visualization vis,  int orientation ) {
		this(vis, DEFAULT_SIZE, orientation);
	}
	
	public VisualizationHeaderDisplayer(Visualization vis, int defaultSize, int orientation ) {
		this.visualization = (MatrixVisualization) vis;
		this.orientation = orientation;
		this.defaultSize = defaultSize;
		this.name=DEFAULT_NAME;
		this.defaultLength=DEFAULT_LENGTH;
		this.defaultFontSize=DEFAULT_FONT_SIZE;
		
		
		if (orientation == SwingConstants.HORIZONTAL) {
			setPreferredSize(new Dimension(1000,defaultSize));		
		} else {
			setPreferredSize(new Dimension(defaultSize,1000));
		}
	}
	
	public Dimension  getPreferredSize() {
		if (visualization != null) {
			Rectangle2D bounds = visualization.getBounds();
			if (orientation == SwingConstants.HORIZONTAL)
				return  new Dimension(bounds != null ?(int)bounds.getWidth() : super.getPreferredSize().width, defaultSize);
			else 
				return  new Dimension(defaultSize, bounds != null ?(int)bounds.getHeight() : super.getPreferredSize().height );
		} else {
			return super.getPreferredSize();
		}
	}
	
	public void paint(Graphics g) {
		if (visualization != null) {
			
			Graph graph = visualization.getGraph();
			Table vertices = graph.getVertexTable();
			RowIterator it = null;
			Column labels = vertices.getColumn(name); 
			boolean reshape = (shapes == null || shapes.isEmpty() || shapes.getRowCount() != labels.getRowCount());
			if (shapes == null) shapes = new ObjectColumn("#MarginLabel");
			Rectangle2D bounds = visualization.getBounds();
			double size;
			Font font = visualization.getDefaultFont();
			Map fontMap = font.getAttributes();
			fontMap.put(TextAttribute.SIZE, defaultFontSize);
			g.setFont(Font.getFont(fontMap));
			if (orientation == SwingConstants.HORIZONTAL && labels != null && bounds !=null) {
				size = ((bounds.getWidth() - visualization.getLeftMargin()) / visualization.getColumnPositionCount());
				it = visualization.rowIterator();
				setBounds((int)bounds.getX(), this.getY(), (int)bounds.getWidth(),this.getHeight());
				paintHorizontal(g,it, labels,size);
			} else if (orientation == SwingConstants.VERTICAL && labels != null && bounds !=null) {
				size = (bounds.getHeight() - visualization.getTopMargin()) / visualization.getRowPositionCount();
				setBounds(this.getX(), (int)bounds.getY(), this.getWidth(), (int)bounds.getHeight());
				it = visualization.columnIterator();
				paintVertical(g, it,  labels,size );
			}
		}
	}
	
	protected void paintHorizontal(Graphics g, RowIterator it ,  Column labels, double size) {
		
		Graphics2D g2d = (Graphics2D) g;
		String label = null;
		int vertex=0;
		double x=0;
		Rectangle2D visible = this.getVisibleRect();
		double visX = visible.getX();
		double visW = visible.getWidth();
		double visY = visible.getY();
		double visH = visible.getHeight();
		double max =visX + visW - size;
		int y=this.getY() + this.getHeight() -2 ;
		int margin = visualization.getLeftMargin();
		Rectangle2D.Double rect ;
		FontMetrics fm = g2d.getFontMetrics();
		Rectangle2D maxCharBounds = fm.getMaxCharBounds(g2d);
		int textW;
		float textY=(float) (visible.getCenterY() + fm.getDescent());
		int pos;
		int maxPos = visualization.getColumnPositionCount();
		while(it != null && it.hasNext()  ) {			
			vertex =  it.nextRow();
			if (vertex < maxPos) {
				try {
					pos = visualization.getColumnPosition(vertex);
					x =  pos * size + margin;
					rect=(Rectangle2D.Double) shapes.get(pos);
					if (rect == null) {
						rect = new Rectangle2D.Double();
						shapes.setExtend(pos,rect);	
					} 
					if ((x >=visX  || (visX-x <= size)) && x <= max) {
						rect.setRect(x,visY,size,visH-1);
						
						label = labels.getValueAt(vertex);
						label = (label==null ? "..." : ((label.length() >=defaultLength && defaultLength >0) ? label.substring(0,defaultLength) : label));
						textW = fm.stringWidth(label);
						
						if ( textW <= size || defaultLength <= 0) {
							g2d.setClip(rect.createIntersection(visible));
							g2d.drawString(label,(float)(rect.getCenterX() - textW / 2), textY);
							g2d.setClip(visible);
						}
						g2d.draw(rect);
					} 
				} catch (ArrayIndexOutOfBoundsException e) {
					System.err.println("Synchronization fault in horizontal repaint");
				}
			} 
		}
	}
	

	
	protected void paintVertical(Graphics g, RowIterator it, Column labels, double size) {
		Graphics2D g2d = (Graphics2D) g;
		String label = null;
		int vertex=0;
		double y=0;	
		Rectangle2D visible = this.getVisibleRect();
		double visX = visible.getX();
		double visW = visible.getWidth();
		double visY = visible.getY();
		double visH = visible.getHeight();
		double  max = visY + visH;
		double x=0;
		double margin = visualization.getTopMargin();
		int row;
		Rectangle2D.Double rect;
		FontMetrics fm = g2d.getFontMetrics();
        Rectangle2D maxCharBounds = fm.getMaxCharBounds(g2d);
        int textW;	
        int pos;
        int maxPos = visualization.getColumnPositionCount();
        while(it != null && it.hasNext()) {
        	vertex =  it.nextRow();
        	if (vertex < maxPos) {
        		try {
        			pos = visualization.getRowPosition(vertex);
        			y = pos * size + margin;
        			rect=(Rectangle2D.Double) shapes.get(pos);
        			if (rect == null) {
        				rect = new Rectangle2D.Double();
        				shapes.setExtend(pos,rect);	
        			} 
        			if ((y >= visY || visY - y <= size) && y <= max) {
        				label = labels.getValueAt(vertex);
        				label = (label==null ? "..." : (label.length() >=defaultLength && defaultLength >0 ? label.substring(0,defaultLength) : label));
        				textW = fm.stringWidth(label);
        				rect.setRect(visX,y,visW-1,size);
        				if (textW <= size || defaultLength <= 0) {
        					g2d.setClip(rect.createIntersection(visible));
        					g2d.drawString(label,(float)(rect.getCenterX() - textW / 2), (float)(rect.getCenterY() + fm.getDescent()));
        					g2d.setClip(visible);
        				}
        				g2d.draw(rect);
        			}
        		} catch (ArrayIndexOutOfBoundsException e) {
        			System.err.println("Synchronization fault in vertical repaint");
        		}
        	}
        }
	}
	

	
	/**
	 * @return Returns the name.
	 */
	public synchronized String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public synchronized void setName(String name) {
		this.name = name;
	}
	/**
	 * @return Returns the defaultLength.
	 */
	public synchronized int getDefaultLength() {
		return defaultLength;
	}
	/**
	 * @param defaultLength The defaultLength to set.
	 */
	public synchronized void setDefaultLength(int defaultLength) {
		this.defaultLength = defaultLength;
	}
	/**
	 * @return Returns the defaultSize.
	 */
	public synchronized int getDefaultSize() {
		return defaultSize;
	}
	/**
	 * @param defaultSize The defaultSize to set.
	 */
	public synchronized void setDefaultSize(int defaultSize) {
		this.defaultSize = defaultSize;
	}
	/**
	 * @return Returns the orientation.
	 */
	public synchronized int getOrientation() {
		return orientation;
	}
	/**
	 * @param orientation The orientation to set.
	 */
	public synchronized void setOrientation(int orientation) {
		if (orientation == SwingConstants.HORIZONTAL || orientation == SwingConstants.VERTICAL)  this.orientation = orientation;
	}
	/**
	 * @return Returns the visualization.
	 */
	public synchronized MatrixVisualization getVisualization() {
		return visualization;
	}
	/**
	 * @param visualization The visualization to set.
	 */
	public synchronized void setVisualization(MatrixVisualization visualization) {
		this.visualization = visualization;
	}
	/**
	 * @return Returns the defaultFontSize.
	 */
	public synchronized Float getDefaultFontSize() {
		return defaultFontSize;
	}
	/**
	 * @param defaultFontSize The defaultFontSize to set.
	 */
	public synchronized void setDefaultFontSize(Float defaultFontSize) {
		this.defaultFontSize = defaultFontSize;
	}
}
