/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 17 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing;

import java.util.Collection;
import java.util.Iterator;
import java.util.Vector;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.ElementEventHandler;


/**
 * @author raf
 *
 * @
 */
public  class DefaultElementHandler implements ElementEventHandler{
    protected ContentHandler parent;
    protected int depth;
    protected int count;
    protected Collection events;
    private Iterator it;

    /**
     * 
     */
    public DefaultElementHandler(ContentHandler p) {
        parent = p;
        depth = 0;
        count =0;
        events=null;
    }
    /**
     * @return
     */
    private Collection buildEvents() {
        return new Vector();
    }
    /**
     * @param o
     * @return
     */
    // remove duplicate ! If not, this will generate two same events for tne same element !
    public boolean addEvent(Event ev) {
        if (events == null) {
            events=this.buildEvents();
        } else {
            it=events.iterator();
            	while(it != null && it.hasNext()) {
            	    if ((it.next()).getClass() == ev.getClass()) return false; 
            	}
        }
        return events.add(ev);
    }
    /**
     * @param c
     * @return
     */
    public boolean removeEvent(Event ev) {
        if (events != null)
            return events.remove(ev);
        else
            return false;
    }
    /**
     * @return Returns the events.
     */
    public Collection getEvents() {
        return events;
    }
    /**
     * @param events The events to set.
     */
    public void setEvents(Collection events) {
        this.events = events;
    }
 
    
    /**
     * @return Returns the count.
     */
    public int getCount() {
        return count;
    }
    /**
     * @param count The count to set.
     */
    public void setCount(int count) {
        this.count = count;
    }
    
    public void count() {
        count++;
    }
    /**
     * @return Returns the parent.
     */
    public ContentHandler getParent() {
        return parent;
    }
    /**
     * @param parent The parent to set.
     */
    public void setParent(ContentHandler parent) {
        this.parent = parent;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.ElementEventHandler#depth()
     */
    public int depth() {
        return depth;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.ElementEventHandler#updateCount()
     */
    public void updateCount() {
        count++;

    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.ElementEventHandler#updateDepth(int)
     */
    public void updateDepth(int step) {
        depth = Math.max(0,depth+step);
    }

}

