/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 19 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing;

import java.util.Iterator;
import java.util.Stack;


/**
 * @author raf
 *
 * @
 */
public abstract class ElementHierarchyHandlerImpl implements ElementHierarchyHandler {

    protected Stack elements;
    /**
     * 
     */
    public ElementHierarchyHandlerImpl() {
    }

      /**
     * @return
     */
    public boolean isEmpty() {
        return (elements == null ? true :elements.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (elements == null ? null :elements.iterator());
    }
    /**
     * @return
     */
    public String peek() {
        return ((elements == null || elements.isEmpty()) ? null : (String) elements.peek());
    }
    /**
     * @return
     */
    public String pop() {
    	String popped=((elements == null ||elements.isEmpty())   ? null :(String) elements.pop());
		if (logger.isDebugEnabled()) logger.info("Popping "+popped);
        return popped;
    }
    /**
     * @param item
     * @return
     */
    public String push(String item) {
    	String current;
        if (item == null || item == "") {
        	logger.warn("Pushing null value");
        	return null;
        }
        if (elements == null) {
        	elements = new Stack();
        	current ="";
        } else if (elements.isEmpty() ){
        	current ="";
        } else {
        	current = (String) elements.peek();
        }
        if (current == null || current =="") {
        	if (logger.isDebugEnabled()) logger.info("Pushing "+item);
        	return (String) elements.push(item.intern());
        } else {
        	if (logger.isDebugEnabled()) logger.info("Pushing "+Context.compose(current,item));
        	return (String) elements.push(Context.compose(current,item));
        }        
    }
    /**
     * @return
     */
    public int size() {
        return (elements == null ? 0 :elements.size());
    }
    /**
     * @return
     */
    public String[] toArray() {
        return (elements == null ? null :(String[])elements.toArray());
    }
    /**
     * 
     */
    public void clear() {
        if (elements != null) elements.clear();
    }
    /**
     * @param elem
     * @return
     */
    public boolean contains(String elem) {
        return elements.contains(elem);
    }
   /* 
    public static String buildHierachicElement(String current, String element) {
    	return Context.compose(current, element);
    }
    */
}
