/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 16 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.event;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

/**
 * @author raf
 *
 * @
 */


public class DefaultEventListenerManager extends EventListenerManagerImpl {
    public void fireEvent(Event e) {
    	Class t=e.getClass();
        EventListener[] lList = getListeners(t); // not a very efficient implementation !
        if (lList != null) {
        	Object ev[] = new Object[1];
        	ev[0]=e;
        	Class l;
        	Method[] methods;
        	Class[] params;
        	boolean called = false;
        	if(logger.isDebugEnabled()) logger.info("Must notify"+lList.length+" "+lList);
      //  	for (int i = lList.length-1; i>=0; i-=1) {
        	for (int i = 0; i<lList.length; i++) {
        		l=null;
        		methods=null;
        		called = false;
        		if(logger.isDebugEnabled()) logger.info("Firing event "+e+" to listener#"+i+" "+lList[i]);
        		l=lList[i].getClass();
        		methods=l.getMethods();
        		for(int m=methods.length-1;m >=0  && !called; m--) {
        			//             if(logger.isDebugEnabled()) logger.info("Trying to find specific method "+m+"/"+(methods.length-1)+" "+methods[m].getName());
        			if ("eventProcess".equals(methods[m].getName()) && Modifier.isPublic(methods[m].getModifiers())) {
        				if(logger.isDebugEnabled())logger.warn("Method "+m+" is an EventProcess and is accessible");
        				params=methods[m].getParameterTypes();
        				if(logger.isDebugEnabled())logger.warn("Method "+m+" Parameters("+params.length+"):"+params[0]+" assignable:"+params[0].isInstance(e));
        				if (params.length == 1 && 
        						params[0] != Event.class && 
								params[0].isInstance(e)) {
        					if(logger.isDebugEnabled())logger.info("Invoking Method "+methods[m]+" with listener:"+lList[i]+" and event "+ev);
        					try {                         
        						methods[m].invoke(lList[i],ev);
        						called =true;
        					} catch (IllegalArgumentException arg) {
        						logger.error("Event listener does not listen this class of event ",arg);
        					} catch (IllegalAccessException acc) {
        						logger.error("Listener is not publically handling this event ",acc);
        					} catch (InvocationTargetException trg) {
        						logger.error("Target "+ trg.getMessage()+ " is inaccessible ",trg);
        					}
        				} 
        			} 
        		}
        		if (!called) lList[i].eventProcess(e); // finally not found !
        	}
        	logger.info("All listeners fired");
        } else {
        	logger.warn("No listeners for this event"); 
        }
    }

}

