/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.CauseEvent;
import fr.inria.oadymppac.parsing.info.CauseInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicCauseEvent extends EventImpl implements CauseEvent {
    
   private String buffer;
    
    protected CauseInfo info;
    /**
     * 
     */
    public BasicCauseEvent() {
        super();
        buildInfo();
    }
    protected void buildInfo() {
		if (info==null) info = new CauseInfo();
	}
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */    
    protected short extractType(Attributes atts) {
    	Event.logger.info("Extracting update type");
    	buffer = atts.getValue(EVENT_TYPE);
    	if (buffer != null) {
    		if (buffer.equals(GROUND)) {
    			Event.logger.info("Ground update detected !");
    			return TYPE_GROUND;
    		} else if (buffer.equals(MIN)) {
    			Event.logger.info("Min update detected !");
    			return TYPE_MIN;
    		} else if (buffer.equals(MAX)) {
    			Event.logger.info("Max update detected !");
    			return TYPE_MAX;
    		} else if (buffer.equals(MINMAX)) {
    			Event.logger.info("Minmax update detected !");
    			return TYPE_MINMAX;
    		} else if (buffer.equals(VALUE)) {
    			Event.logger.info(" VALUE detected !");
    			return TYPE_VALUE;
    		} else if (buffer.equals(ANY)) {
    			Event.logger.info(" Any update detected !");
    			return TYPE_ANY;
    		} else if (buffer.equals(EMPTY)) {
    			Event.logger.info(" Empty update detected !");
    			return TYPE_EMPTY;
    		} else if (buffer.equals(NOTHING)) {
    			Event.logger.info(" Nothing update detected !");
    			return TYPE_NOTHING;
    		} else {
    			Event.logger.warn("Impossible to detect variable type!");
    			return TYPE_NONE;
    		}
    	} else {
    		return TYPE_NONE;
    	}
    }


    /**
     * @return
     */
    public String getVariable() {
        return  info.getVariable();
    }
    /**
     * @return Returns the info.
     */
    public Info getInfo() {
        return (Info)info;
    }
    /**
     * @return
     */
    public short getType() {
        return  info.getType();
    }
    
    
    
   
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setVariable(extractString(VARIABLE,atts, VARIABLE_NONE));
        setType(extractType(atts));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset();
    	if (info != null) {
        setVariable(VARIABLE_NONE);
        setType(TYPE_NONE);
        info=null;
    	}
    }
    /**
     * @param ident
     */
    public void setVariable(String ident) {
        info.setVariable(ident);
    }
 
    /**
     * @param type
     */
    public void setType(short type) {
        info.setType(type);
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}