/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import java.util.StringTokenizer;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoiceConstraintEvent;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicChoiceConstraintEvent extends EventImpl implements ChoiceConstraintEvent {
   
    protected ChoiceConstraintInfo info;
    
    private String buffer;
    private StringTokenizer tokenizer;
    /**
     * 
     */
    public BasicChoiceConstraintEvent() {
        super();
        buildInfo();
    }
     
    protected void buildInfo() {
		if (info==null) info = new ChoiceConstraintInfo();
	}
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setVariable(extractString(VARIABLE,atts, VARIABLE_NONE));
        setValue(extractInt(VALUE,atts, VALUE_NONE));
        setConstraints(extractConstraints(atts));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset();
    	if (info != null) {
        
        setVariable( VARIABLE_NONE);
        setValue(VALUE_NONE);
        setConstraints(CONSTRAINTS_NONE);
        info = null;
    	}
    }
   
    /**
     * @return
     */
    public String[] getConstraints() {
        return info.getConstraints();
    }
    /**
     * @return
     */
    public int getValue() {
        return info.getValue();
    }
    /**
     * @return
     */
    public String getVariable() {
        return info.getVariable();
    }
    /**
     * @param constraints
     */
    public void setConstraints(String[] constraints) {
        info.setConstraints(constraints);
    }
    /**
     * @param value
     */
    public void setValue(int value) {
        info.setValue(value);
    }
    /**
     * @param variable
     */
    public void setVariable(String variable) {
        info.setVariable(variable);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#getInfo()
     */
    public Info getInfo() throws CloneNotSupportedException {
        return (Info) info;
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */    
    protected String[] extractConstraints(Attributes atts) {
        logger.info("Extracting references");
        buffer = atts.getValue(CONSTRAINTS);
        int i;
        String[] result;
        if (buffer != null) {
            tokenizer=new StringTokenizer(buffer,CONSTRAINTS_SEPARATOR);
            i=tokenizer.countTokens();
            if (i >0 ) {
                result= new String[i];
                i=0;
            } else {
                return CONSTRAINTS_NONE;
            }
            while(tokenizer.hasMoreTokens()) {
                result[i++]=tokenizer.nextToken();
             }
            return result;
        } else {
            return CONSTRAINTS_NONE;
        }
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}
