/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent;
import fr.inria.oadymppac.parsing.info.RemoveInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicRemoveEvent extends BasicEvent implements RemoveEvent {

     RemoveInfo info;
    /**
     * 
     */
    public BasicRemoveEvent() {
        super();
        buildInfo();
    }
    protected void buildInfo() {
		if (info==null) info = new RemoveInfo();
	}
	
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getChrono()
     */
    public int getChrono() {
        return info.getChrono();
    }
    /**
     * @return
     */
    public String getConstraint() {
        return info.getConstraint();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getContext()
     */
    public String getContext() {
        return info.getContext();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getDepth()
     */
    public int getDepth() {
        return info.getDepth();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getFile()
     */
    public String getFile() {
        return info.getFile();
    }

     /**
     * @return Returns the info.
     */
    public Info getInfo() {
        return (Info)info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getLine()
     */
    public int getLine() {
        return info.getLine();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#getTime()
     */
    public long getTime() {
        return info.getTime();
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setConstraint(extractString(CONSTRAINT,atts, CONSTRAINT_NONE));
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
        super.reset();
        setConstraint(CONSTRAINT_NONE);
        info = null;
    	}
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setChrono(int)
     */
    public void setChrono(int chrono) {
        info.setChrono(chrono);
    }
    /**
     * @param cst
     */
    public void setConstraint(String cst) {
        info.setConstraint(cst);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setContext(java.lang.String)
     */
    public void setContext(String context) {
        info.setContext(context);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setDepth(int)
     */
    public void setDepth(int depth) {
        info.setDepth(depth);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setFile(java.lang.String)
     */
    public void setFile(String file) {
        info.setFile(file);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setLine(int)
     */
    public void setLine(int line) {
        info.setLine(line);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.BasicEvent#setTime(long)
     */
    public void setTime(long time) {
        info.setTime(time);
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}