/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.VarDomainEvent;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicVarDomainEvent extends EventImpl implements VarDomainEvent {
    
    protected VarDomainInfo info;

    /**
     * 
     */
    public BasicVarDomainEvent() {
        super();
        buildInfo();
    }

    protected void buildInfo() {
		if (info==null) info = new VarDomainInfo();
	}
	

   
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, org.xml.sax.Attributes)
     */
    public void init(ContentHandler handler, Attributes atts) {
    	buildInfo();
        super.init(handler, atts);
        setMin(extractInt(MIN,atts, MIN_NONE));
        setMax(extractInt(MAX,atts, MAX_NONE));
        setSize(extractInt(SIZE,atts, SIZE_NONE));
        
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset();
    	if (info != null) {
        setMin(MIN_NONE);
        setMax(MAX_NONE);
        setSize(SIZE_NONE);
        info=null;
    	}
    }

    /**
     * @return
     */
    public int getMax() {
        return info.getMax();
    }
    /**
     * @return
     */
    public int getMin() {
        return info.getMin();
    }
    /**
     * @return
     */
    public int getSize() {
        return info.getSize();
    }
    /**
     * @param max
     */
    public void setMax(int max) {
        info.setMax(max);
    }
    /**
     * @param min
     */
    public void setMin(int min) {
        info.setMin(min);
    }
    /**
     * @param size
     */
    public void setSize(int size) {
        info.setSize(size);
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#getInfo()
     */
    public Info getInfo() throws CloneNotSupportedException {
        return (Info) info;
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}