/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import java.util.StringTokenizer;

import org.xml.sax.Attributes;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.VariablesEvent;
import fr.inria.oadymppac.parsing.info.VariablesInfo;


/**
 * @author raf
 *
 * @
 */
public class BasicVariablesEvent extends EventImpl implements VariablesEvent,  Event
			 {
    
    private String buffer;
 
    protected VariablesInfo info;
    private StringTokenizer tokenizer;
 
  
    /**
     * 
     */
    public BasicVariablesEvent() {
        super();
        buildInfo();
    }

    protected void buildInfo() {
		if (info==null) info = new VariablesInfo();
	}
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */    
    protected String[] extractIdentifiers(Attributes atts) {
        Event.logger.info("Extracting identifiers");
        buffer = atts.getValue(IDENTIFIERS);
        return extractIdentifiers(buffer);
    }
    protected String[] extractIdentifiers(String base) {
        int i;
        String[] result;
        if (base != null) {
            tokenizer=new StringTokenizer(base,IDENTIFIERS_SEPARATOR);
            i=tokenizer.countTokens();
            if (i >0 ) {
                result= new String[i];
                i=0;
            } else {
                return IDENTIFIERS_NONE;
            }
            while(tokenizer.hasMoreTokens()) {
                result[i++]=tokenizer.nextToken();
             }
            return result;
        } else {
            return IDENTIFIERS_NONE;
        }
    }
    
    
    

    /**
     * @return
     */
    public String[] getIdentifiers() {
        return info.getIdentifiers();
    }
     
  
 
    
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset(); 
    	if (info != null) {
        setIdentifiers(IDENTIFIERS_NONE);
        info=null;
    	}
    }
 
    /**
     * @param identifiers
     */
    public void setIdentifiers(String[] identifiers) {
        info.setIdentifiers(identifiers);
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#getInfo()
     */
    public Info getInfo() throws CloneNotSupportedException {
        return (Info) info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.parsing.ContentHandler, char[], int, int)
     */
    public void init(ContentHandler handler, char[] ch, int start, int length) {
    	buildInfo();
        super.init(handler, ch, start, length);
        setIdentifiers(extractIdentifiers(String.copyValueOf(ch, start, length)));
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}