/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
            	COSYTEC
*		    	4 rue Jean Rostand
* 				91893 Orsay Cedex, France
*				Tel. +33 1 60 19 37 38
*				Fax. +33 1 60 19 36 20
*
* Purpose	: COMPLETE HERE
 * 
 * Created on 9 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventListener;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDBreakPointElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDComplementElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDHeadElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDPacketElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDProvideElement;
import fr.inria.oadymppac.parsing.gentra4cp.event.ProvideEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.handlers.*;


/**
 * @author raf
 *
 * @
 */
public class ControlContentHandler extends TopLevelContentHandler {

    protected HeadContentHandler headHandler;
    protected ProvideContentHandler provideHandler;
    protected ComplementContentHandler complementHandler;
    
    
    public ControlContentHandler() {
        super();
        headHandler = new HeadContentHandler();
        provideHandler = new ProvideContentHandler();
        complementHandler = new ComplementContentHandler();
   /*     try {
        	super.addElement(DTDPacketElement.PACKET, DefaultPacketEvent.class);
        	setContextOffset(DTDPacketElement.PACKET);
            super.addElement(DTDBreakPointElement.BREAKPOINT, DefaultBreakPointEvent.class);
        } catch (ClassNotFoundException e) {
            ContentHandler.logger.error("Impossible to find class of Event",e);
        } catch (InstantiationException e) {
            ContentHandler.logger.error("Impossible to generate a new instance of Event",e);
        } catch (IllegalAccessException e) {
            ContentHandler.logger.error("Illegal method call to generate a new instance of Event",e);
        }
        */
        
     }
 
    public void addDefaultListener(EventListener solverListener) {     
        
        try {
            super.addElement(DTDPacketElement.PACKET, DefaultPacketEvent.class);	
        	super.addElement(DTDBreakPointElement.BREAKPOINT, DefaultBreakPointEvent.class);
        	addDelegateHandler(DTDComplementElement.COMPLEMENT, complementHandler);
        	addDelegateHandler(DTDProvideElement.PROVIDE, provideHandler);
        	addDelegateHandler(DTDHeadElement.HEAD, headHandler);
            
        } catch (ClassNotFoundException e) {
            ContentHandler.logger.error("Impossible to find class of Event",e);
        } catch (InstantiationException e) {
            ContentHandler.logger.error("Impossible to generate a new instance of Event",e);
        } catch (IllegalAccessException e) {
            ContentHandler.logger.error("Illegal method call to generate a new instance of Event",e);
        } catch (Exception e) {
            ContentHandler.logger.error("Undetermined Exception",e);
        }
        addContextOffset(DTDPacketElement.PACKET);
        super.addDefaultListener(solverListener);
        //complementHandler.addContextOffset(DTDPacketElement.PACKET);
        complementHandler.addDefaultListener(solverListener);
        
}
 
    public void addComplementListener(EventListener listener) {
        complementHandler.addListener(DefaultComplementEvent.class, listener);
    }
    public void addHeadListener(EventListener listener) {
        headHandler.addListener(DefaultDateEvent.class,listener );
        headHandler.addListener(DefaultSourceEvent.class,listener );
        headHandler.addListener(DefaultCreatorEvent.class,listener );
        headHandler.addListener(DefaultContributorEvent.class,listener );
        headHandler.addListener(DefaultDescriptionEvent.class,listener );
        headHandler.addListener(DefaultRightsEvent.class,listener );
        headHandler.addListener(DefaultSolverEvent.class,listener );
        headHandler.addListener(DefaultParametersEvent.class,listener );
        headHandler.addListener(DefaultChecksumEvent.class,listener ); 
    }
    public void addProvidedListener(EventListener listener) {
        provideHandler.addListener(DefaultProvideEvent.class, listener);
    }
    
    public void addProvidableListener(ProvideEventListener providableListener) {
        headHandler.getProvide().addListener(DefaultProvideEvent.class, providableListener);
    }
}
