/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationCommandEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationCommandEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent;
import fr.inria.oadymppac.parsing.info.AnnotationCommandInfo;
import fr.inria.oadymppac.parsing.info.AnnotationCommandProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultAnnotationEvent extends BasicAnnotationEvent 
									implements AnnotationEvent, AnnotationCommandProvider,
									           AnnotationCommandEventListener
			 { 
   
    
    /**
     * @return
     */
    public AnnotationCommandInfo getCommand() {
        return info == null ? null : info.getCommand();
    }
    
    /**
     * @param command
     */
    public void setCommand(AnnotationCommandInfo command) {
        buildInfo();
        info.setCommand(command);
    }

    public void reset() {
    	if (info != null) {
    		setCommand(null);
    		super.reset();
    	}
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationCommandEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationCommandEvent)
     */
    public void eventProcess(AnnotationCommandEvent ev) {
    	if (info != null) {
    		try {
    			AnnotationCommandInfo cmd = (AnnotationCommandInfo)ev.getInfo();
    			info.setCommand((cmd == null ? null :(AnnotationCommandInfo)cmd.clone()));
    		} catch (CloneNotSupportedException e) {
    			Event.logger.error("Impossible to clone the Annotation Command",e);
    		} catch (ClassCastException e) {
    			Event.logger.error("Impossible to convert to an Annotation Command",e);
    		}
    	}
    }
    public void eventProcess(Event ev) {};
    
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}