/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 17 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.event.EventImpl;
import fr.inria.oadymppac.parsing.event.Info;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DateEvent;


/**
 * @author raf
 *
 * @
 */
public class DefaultDateEvent extends EventImpl implements DateEvent {
    protected static DateFormat format = new SimpleDateFormat(DEFAULT_DATE_FORMAT);
    
    protected Date date;
    
    protected void buildInfo() {}
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.header.attributes.DateAttributes#getDate()
     */
    public Date getDate() {
        return date;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.header.attributes.DateAttributes#setDate(java.util.Date)
     */
    public void setDate(Date d) {
        date=d;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#init(fr.inria.oadymppac.ContentHandler, char[], int, int)
     */
    public void init(ContentHandler handler, char[] ch, int start, int length) {
        String ds = String.copyValueOf(ch,start,length);
        if (logger.isDebugEnabled()) logger.info("Parsed date " + ds); 
        try {
            setDate(ds==null ? DATE_NONE: format.parse(ds));
        } catch (ParseException e) {
        	if (logger.isDebugEnabled()) logger.error("Impossible to parse the date from string:"+ds, e);
        }
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	super.reset();
        setDate(DATE_NONE);
    }

    public Info getInfo() throws CloneNotSupportedException {
        return null;
    }
    
    public int getEventType() {
		return EVENT_TYPE;
	}
}
