/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StageCommentEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StageCommentEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.StageCommentInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;

/**
 * @author raf @
 */
public class DefaultNewStageEvent extends BasicNewStageEvent implements
        NewStageEvent, StageCommentEventListener, StateProvider,
        StateEventListener {

    protected StateListenerDecoratorImpl stateDecorator;

    public DefaultNewStageEvent() {
        stateDecorator = new DefaultStateListenerDecorator(this);
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }

    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.StageCommentEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.StageCommentEvent)
     */
    public void eventProcess(StageCommentEvent ev) {
    	if (info != null) {
    		try {
    			StageCommentInfo cmd = (StageCommentInfo) ev.getInfo();
    			info.setComment((cmd == null ? null :(StageCommentInfo) cmd.clone()));
    			//ev.reset();
    		} catch (CloneNotSupportedException e) {
    			Event.logger.error("Impossible to clone the Stage Comment", e);
    		} catch (ClassCastException e) {
    			Event.logger.error("Impossible to convert to an Stage Comment", e);
    		}
    	}
    }

    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }

    /**
     * @return
     */
    public StageCommentInfo getComment() {
        return info == null ? null : info.getComment();
    }

    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }

    public void reset() {
    	if (info != null) {
    	   	setComment(null);
        	super.reset();
     }
    }

    /**
     * @param command
     */
    public void setComment(StageCommentInfo command) {
        buildInfo();
        info.setComment(command);
    }

    /**
     * @param state
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    };
    
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}