/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.DeltaListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.StateProvider;
import fr.inria.oadymppac.parsing.info.DeltaListInfo;
import fr.inria.oadymppac.parsing.info.DeltaListProvider;


/**
 * @author raf
 *
 * @
 */
public class DefaultRestoreEvent extends BasicRestoreEvent implements RestoreEvent,DeltaListProvider , DeltaEventListener, StateProvider, StateEventListener {
    protected StateListenerDecoratorImpl stateDecorator;
 

    protected DeltaListListenerDecoratorImpl deltaListDecorator;
    
    public DefaultRestoreEvent() {
        deltaListDecorator =new DefaultDeltaListListenerDecorator(this);
        stateDecorator= new DefaultStateListenerDecorator(this);
    }
 
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventListener#eventProcess(fr.inria.oadymppac.parsing.event.Event)
     */
    public void eventProcess(Event e) {
    }
    /**
     * @param ev
     */
    public void eventProcess(StateEvent ev) {
    	if (info != null) stateDecorator.eventProcess(ev);
    }
 
    /**
     * @param ev
     */
    public void eventProcess(DeltaEvent ev) {
        if (info != null) deltaListDecorator.eventProcess(ev);
    }
    


    /**
     * @return
     */
    public StateInfo getState() {
        return info == null ? null : info.getState();
    }

    /**
     * @return
     */
    public DeltaListInfo getDeltaList() {
        return info == null ? null : info.getDeltaList();
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		
        deltaListDecorator.reset();
        stateDecorator.reset();
        super.reset();
    	}
    }
    /**
     * @param state
     */
    public void setState(StateInfo state) {
        buildInfo();
        info.setState(state);
    }

    /**
     * @param deltaList
     */
    public void setDeltaList(DeltaListInfo deltaList) {
        buildInfo();
        info.setDeltaList(deltaList);
    }
    /* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {};
}