/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp;

import fr.inria.oadymppac.parsing.gentra4cp.event.ExplanationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ExplanationEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.ExplanationListListenerDecoratorImpl;
import fr.inria.oadymppac.parsing.info.ExplanationListInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListProvider;


/**
 * @author raf
 *
 * @
 */
public class ExplanationReduceEvent extends  DefaultReduceEvent implements ExplanationListProvider, ExplanationEventListener {
    
    protected ExplanationListListenerDecoratorImpl explanationDecorator;

 
    
    public ExplanationReduceEvent() {
        super();
        
        explanationDecorator= new DefaultExplanationListListenerDecorator(this);
    }
     
  
    
    
    /**
     * @param ev
     */
    public void eventProcess(ExplanationEvent ev) {
    	if (info != null) explanationDecorator.eventProcess(ev);
    }
 
    
   


    /**
     * @return
     */
    public ExplanationListInfo getExplanationList() {
        return info == null ? null : info.getExplanationList();
    }



    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		explanationDecorator.reset();
    		super.reset();
    	}
    }
    /**
     * @param state
     */
    public void setExplanationList(ExplanationListInfo explanations) {
        buildInfo();
        info.setExplanationList(explanations);
    }



    
}