/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ChoiceConstraintListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class ChoiceConstraintListListenerDecoratorImpl extends InfoDecoratorImpl implements ChoiceConstraintListListenerDecorator, ChoiceConstraintListProvider {

    protected ChoiceConstraintListInfo info;
    protected ChoiceConstraintListProvider provider;
    
    /**
     * @param ev
     */
    public ChoiceConstraintListListenerDecoratorImpl(ChoiceConstraintListProvider provider) {
        this.provider = provider;
        
    
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEvent)
	 */
	public void eventProcess(ChoiceConstraintEvent ev) {
		Event.logger.info("ChoiceConstraint Domain event "+ev);
		if (provider.getChoiceConstraintList() == null) {
            info =new ChoiceConstraintListInfo();
            provider.setChoiceConstraintList(info);
        }else {
            info = provider.getChoiceConstraintList();
        }
		try {
		    ChoiceConstraintInfo current = (ChoiceConstraintInfo)ev.getInfo();
		    if (current != null) add( (ChoiceConstraintInfo)current.clone());
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the ChoiceConstraint",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a ChoiceConstraint",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		info.clear();
    		super.reset();
    	}      
    }
    

  
    /**
     * @return Returns the info.
     */
    public ChoiceConstraintListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(ChoiceConstraintListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(ChoiceConstraintInfo constraint) {
        if (info == null) info = new ChoiceConstraintListInfo();
        return info.add(constraint);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(ChoiceConstraintInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#terminate()
     */
 /*   public void terminate() {
        super.terminate();
        if (logger.isDebugEnabled()) logger.info("Updating ChoiceConstraintListProvider by setting ChoiceConstraintList into "+provider+" via "+this);
        try {
            provider.setChoiceConstraintList((ChoiceConstraintListInfo)info.clone());
        } catch (ClassCastException cst) {
            logger.error("Impossible to cast event into ChoiceConstraintListProvider",cst);
        } catch (CloneNotSupportedException cln) {
            logger.error("Impossible to clone the constraintList",cln);
        }
    }
  
*/
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.ChoiceConstraintListProvider#getChoiceConstraintList()
     */
    public ChoiceConstraintListInfo getChoiceConstraintList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.ChoiceConstraintListProvider#setChoiceConstraintList(fr.inria.oadymppac.parsing.info.ChoiceConstraintListInfo)
     */
    public void setChoiceConstraintList(ChoiceConstraintListInfo constraintList) {
       this.info=constraintList;

    }
    
}
