/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.ConstraintInfo;
import fr.inria.oadymppac.parsing.info.ConstraintListInfo;
import fr.inria.oadymppac.parsing.info.ConstraintListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class ConstraintListListenerDecoratorImpl extends InfoDecoratorImpl implements ConstraintListListenerDecorator, ConstraintListProvider {

    protected ConstraintListInfo info;
    protected ConstraintListProvider provider;
    
    /**
     * @param ev
     */
    public ConstraintListListenerDecoratorImpl(ConstraintListProvider provider) {
        this.provider = provider;
        
    
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintRangeEvent)
	 */
	public void eventProcess(ConstraintEvent ev) {
		Event.logger.info("Constraint Domain event "+ev);
		if (provider.getConstraintList() == null) {
            info =new ConstraintListInfo();
            provider.setConstraintList(info);
        }else {
            info = provider.getConstraintList();
        }
		try {
		    ConstraintInfo current = (ConstraintInfo)ev.getInfo();
		    if (current != null) add((ConstraintInfo)current.clone());
		   // ev.reset();
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the Constraint",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a Constraint",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		info.clear();
    		super.reset();
    	}  
    }
    

  
    /**
     * @return Returns the info.
     */
    public ConstraintListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(ConstraintListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(ConstraintInfo update) {
        if (info == null) info = new ConstraintListInfo();
        return info.add(update);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(ConstraintInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#terminate()
     */
 /*   public void terminate() {
        super.terminate();
        if (logger.isDebugEnabled()) logger.info("Updating ConstraintListProvider by setting ConstraintList into "+provider+" via "+this);
        try {
            provider.setConstraintList((ConstraintListInfo)info.clone());
        } catch (ClassCastException cst) {
            logger.error("Impossible to cast event into ConstraintListProvider",cst);
        } catch (CloneNotSupportedException cln) {
            logger.error("Impossible to clone the updateList",cln);
        }
    }
  
*/
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.ConstraintListProvider#getConstraintList()
     */
    public ConstraintListInfo getConstraintList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.ConstraintListProvider#setConstraintList(fr.inria.oadymppac.parsing.info.ConstraintListInfo)
     */
    public void setConstraintList(ConstraintListInfo constraintList) {
       this.info=constraintList;

    }
}
