/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.ExplanationInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class ExplanationListListenerDecoratorImpl extends InfoDecoratorImpl implements ExplanationListListenerDecorator, ExplanationListProvider {

    protected ExplanationListInfo info;
    protected ExplanationListProvider provider;
    
    /**
     * @param ev
     */
    public ExplanationListListenerDecoratorImpl(ExplanationListProvider provider) {
        this.provider = provider;
        
    
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewExplanationRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewExplanationRangeEvent)
	 */
	public void eventProcess(ExplanationEvent ev) {
		Event.logger.info("Explanation Domain event "+ev);
		if (provider.getExplanationList() == null) {
            info =new ExplanationListInfo();
            provider.setExplanationList(info);
        }else {
            info = provider.getExplanationList();
        }
		try {
		    ExplanationInfo current = (ExplanationInfo)ev.getInfo();
		    if (current != null) add((ExplanationInfo)current.clone());
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the Explanation",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a Explanation",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info !=null) {
    		info.clear();
    		super.reset();
    	}
    }
    

  
    /**
     * @return Returns the info.
     */
    public ExplanationListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(ExplanationListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(ExplanationInfo update) {
        if (info == null) info = new ExplanationListInfo();
        return info.add(update);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(ExplanationInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   
  
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.ExplanationListProvider#getExplanationList()
     */
    public ExplanationListInfo getExplanationList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.ExplanationListProvider#setExplanationList(fr.inria.oadymppac.parsing.info.ExplanationListInfo)
     */
    public void setExplanationList(ExplanationListInfo explanationList) {
       this.info=explanationList;

    }
}
