/*
 * Created on 26 mars 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.parsing.gentra4cp.event;

import java.util.Iterator;

import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.InfoDecoratorImpl;
import fr.inria.oadymppac.parsing.info.UpdateInfo;
import fr.inria.oadymppac.parsing.info.UpdateListInfo;
import fr.inria.oadymppac.parsing.info.UpdateListProvider;


/**
 * @author raf
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class UpdateListListenerDecoratorImpl extends InfoDecoratorImpl implements UpdateListListenerDecorator, UpdateListProvider {

    protected UpdateListInfo info;
    protected UpdateListProvider provider;
    
    /**
     * @param ev
     */
    public UpdateListListenerDecoratorImpl(UpdateListProvider provider) {
        this.provider = provider;
    }

	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEventListener#eventProcess(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableRangeEvent)
	 */
	public void eventProcess(UpdateEvent ev) {
		Event.logger.info("Update Domain event "+ev);
		if (provider.getUpdateList() == null) {
            info =new UpdateListInfo();
            provider.setUpdateList(info);
        }else {
            info = provider.getUpdateList();
        }
		try {
		    UpdateInfo current = (UpdateInfo)ev.getInfo();
		    if (current != null) add((UpdateInfo)current.clone());
//		    ev.reset();
		} catch (CloneNotSupportedException e) {
			Event.logger.error("Impossible to clone the Update",e);
		} catch (ClassCastException e) {
		    Event.logger.error("Impossible to convert to a Update",e);
		}
	}


    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#reset()
     */
    public void reset() {
    	if (info != null) {
    		info.clear();
    		super.reset();
    	}
        
    }
    

  
    /**
     * @return Returns the info.
     */
    public UpdateListInfo getInfo() {
        return info;
    }
    /**
     * @param info The info to set.
     */
    public void setInfo(UpdateListInfo info) {
        this.info = info;
    }
    /**
     * @param ri
     * @return
     */
    public boolean add(UpdateInfo update) {
        if (info == null) info = new UpdateListInfo();
        return info.add(update);
    }
 
    /**
     * 
     */
    public void clear() {
        if (info != null) info.clear();
    }
    /**
     * @param o
     * @return
     */
    public boolean contains(UpdateInfo o) {
        return (info == null ? false :info.contains(o));
    }
        
    /**
     * @return
     */
    public boolean isEmpty() {
        return (info == null ? true : info.isEmpty());
    }
    /**
     * @return
     */
    public Iterator iterator() {
        return (info == null ? null :info.iterator());
    }
  
    /**
     * @return
     */
    public int size() {
        return (info == null ? 0 : info.size());
    }
   
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.Event#terminate()
     */
 /*   public void terminate() {
        super.terminate();
        if (logger.isDebugEnabled()) logger.info("Updating UpdateListProvider by setting UpdateList into "+provider+" via "+this);
        try {
            provider.setUpdateList((UpdateListInfo)info.clone());
        } catch (ClassCastException cst) {
            logger.error("Impossible to cast event into UpdateListProvider",cst);
        } catch (CloneNotSupportedException cln) {
            logger.error("Impossible to clone the updateList",cln);
        }
    }
  
*/
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.UpdateListProvider#getUpdateList()
     */
    public UpdateListInfo getUpdateList() {
        return info;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.UpdateListProvider#setUpdateList(fr.inria.oadymppac.parsing.info.UpdateListInfo)
     */
    public void setUpdateList(UpdateListInfo updateList) {
       this.info=updateList;

    }
}
