/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
            	COSYTEC
*		    	4 rue Jean Rostand
* 				91893 Orsay Cedex, France
*				Tel. +33 1 60 19 37 38
*				Fax. +33 1 60 19 36 20
*
* Purpose	: COMPLETE HERE
 * 
 * Created on 9 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp.handlers;

import org.xml.sax.SAXException;

import fr.inria.oadymppac.parsing.ContentHandlerImpl;
import fr.inria.oadymppac.parsing.Context;
import fr.inria.oadymppac.parsing.DefaultElementHandler;
import fr.inria.oadymppac.parsing.event.ElementEventHandler;
import fr.inria.oadymppac.parsing.event.Event;
import fr.inria.oadymppac.parsing.event.EventListenerManager;
import fr.inria.oadymppac.parsing.info.BasicInfo;
import fr.inria.oadymppac.parsing.info.ListInfo;


/**
 * @author raf
 *
 * @
 */
public class FasterContentHandler extends ContentHandlerImpl {
 
    protected String contextOffset;
    
    public FasterContentHandler() {
        super();
    }
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.ContentHandler#buildElementHandler()
     */
    public ElementEventHandler buildElementHandler() {
        return new DefaultElementHandler(this);
    }    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.ContentHandler#buildListenerManager()
     */
    public EventListenerManager buildListenerManager() {
       return new FasterEventListenerManager();
    }
    /**
     * @return Returns the contextOffset.
     */
    public String getContextOffset() {
        return contextOffset;
    }
    /**
     * @param offset The contextOffset to set.
     */
    public void addContextOffset(String offset) {
        if (this.contextOffset == null)
            this.contextOffset = offset.intern();
        else 
            this.contextOffset = Context.compose(this.contextOffset, offset);
    }
    
    /*
     * (non-Javadoc)
     * 
     * @see fr.inria.oadymppac.ContentHandler#addElement(java.lang.String,
     *      fr.inria.oadymppac.parsing.event.Event)
     */
    public Event addElement(String element, Event ev) {
        if (contextOffset != null && element.intern() != contextOffset)
            return super.addElement(Context.compose(contextOffset,element), ev);    
        else
            return super.addElement(element, ev);
    }
    
    public void startDocument() throws SAXException {
    	fired=0;
    	initiated=0;
    	reset=0;
    	BasicInfo.created=0;
    	BasicInfo.cloned=0;
    	ListInfo.created = 0;
    	ListInfo.cloned = 0;
    	super.startDocument();
    }
    
    public void endDocument() throws SAXException {
    	System.out.println("INFO #CREATED:"+BasicInfo.created+" #CLONED:"+BasicInfo.cloned);
    	System.out.println("LIST INFO #CREATED:"+ListInfo.created+" #CLONED:"+ListInfo.cloned);
    	System.out.println("EVENT #INITIATED:"+ContentHandlerImpl.fired+" #FIRED:"+ContentHandlerImpl.fired+" #RESET:"+ContentHandlerImpl.reset);
    	super.endDocument();
    }
}
