/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 9 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.gentra4cp.handlers;

import fr.inria.oadymppac.parsing.ContentHandler;
import fr.inria.oadymppac.parsing.ContentHandlerImpl;
import fr.inria.oadymppac.parsing.DefaultElementHandler;
import fr.inria.oadymppac.parsing.event.DefaultEventListenerManager;
import fr.inria.oadymppac.parsing.event.ElementEventHandler;
import fr.inria.oadymppac.parsing.event.EventListenerManager;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultChecksumEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultContributorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultCreatorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultDateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultDescriptionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultIdentifierEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultParametersEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultRightsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultSolverEvent;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultSourceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDHeadElement;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDProvideElement;
import fr.inria.oadymppac.parsing.info.ProvideInfo;
import fr.inria.oadymppac.parsing.info.ProvideInfoHandler;


/**
 * @author raf
 *
 * @
 */
public class HeadContentHandler extends ContentHandlerImpl implements ProvideInfoHandler {
	protected ProvideContentHandler provide;
	
	public HeadContentHandler() {
		super();
		provide = new ProvideContentHandler();
		try {
			DefaultDateEvent date = (DefaultDateEvent) addElement(DTDHeadElement.DATE, DefaultDateEvent.class);
			DefaultSourceEvent source = (DefaultSourceEvent) addElement(DTDHeadElement.SOURCE, DefaultSourceEvent.class);
			DefaultCreatorEvent creator = (DefaultCreatorEvent) addElement(DTDHeadElement.CREATOR, DefaultCreatorEvent.class);
			DefaultContributorEvent contributor = (DefaultContributorEvent) addElement(DTDHeadElement.CONTRIBUTOR, DefaultContributorEvent.class);
			DefaultDescriptionEvent description = (DefaultDescriptionEvent) addElement(DTDHeadElement.DESCRIPTION, DefaultDescriptionEvent.class);
			DefaultIdentifierEvent identifier = (DefaultIdentifierEvent) addElement(DTDHeadElement.IDENTIFIER, DefaultIdentifierEvent.class);
			DefaultRightsEvent rights = (DefaultRightsEvent) addElement(DTDHeadElement.RIGHTS, DefaultRightsEvent.class);
			DefaultSolverEvent solver = (DefaultSolverEvent) addElement(DTDHeadElement.SOLVER, DefaultSolverEvent.class);
			DefaultParametersEvent parameters = (DefaultParametersEvent) addElement(DTDHeadElement.PARAMETERS, DefaultParametersEvent.class);
			DefaultChecksumEvent checksum = (DefaultChecksumEvent) addElement(DTDHeadElement.CHECKSUM, DefaultChecksumEvent.class);
			addDelegateHandler(DTDProvideElement.PROVIDE, provide);
		} catch (ClassNotFoundException e) {
			ContentHandler.logger.error("Impossible to find class of Event",e);
		} catch (InstantiationException e) {
			ContentHandler.logger.error("Impossible to generate a new instance of Event",e);
		} catch (IllegalAccessException e) {
			ContentHandler.logger.error("Illegal method call to generate a new instance of Event",e);
		}
	}
		
		/* (non-Javadoc)
		 * @see fr.inria.oadymppac.ContentHandler#buildElementHandler()
		 */
		public ElementEventHandler buildElementHandler() {
			return new DefaultElementHandler(this);
		}
		
		public EventListenerManager buildListenerManager() {
			return new DefaultEventListenerManager();
		}
	/**
	 * @return
	 */
	public ProvideInfo buildProvideInfo() {
		return provide.buildProvideInfo();
	}
	/**
	 * @return
	 */
	public ProvideInfo getProvideInfo() {
		return provide.getProvideInfo();
	}
	/**
	 * @param info
	 */
	public void setProvideInfo(ProvideInfo info) {
		provide.setProvideInfo(info);
	}
	
	/**
	 * @return Returns the provide.
	 */
	public ProvideContentHandler getProvide() {
		return provide;
	}
	/**
	 * @param provide The provide to set.
	 */
	public void setProvide(ProvideContentHandler provide) {
		this.provide = provide;
	}
	}



