/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.AnnotationAttributes;


/**
 * @author raf
 *
 * @
 */
public class AnnotationInfo extends EventInfo implements AnnotationAttributes, AnnotationCommandProvider,StateProvider, Cloneable
			 {
	public static final int INFO_TYPE = 2;
	public  int getInfoType() {
		return INFO_TYPE;
	}
	
    protected String identifier;
    protected String name;
    protected short  type;
    protected String[] references;
    
    protected AnnotationCommandInfo command;
    
    protected StateInfo state;
    
 
    
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        AnnotationInfo clone = new AnnotationInfo();
        clone(clone); 
        clone.setIdentifier(identifier);
        clone.setName(name);
        clone.setType(type);
        clone.setReferences(clone(references));
        if(command != null) clone.setCommand(command);
        if(state != null) clone.setState((StateInfo) state.clone());
        return clone;
    }
    
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getIdentifier()
     */
    public String getIdentifier() {
        return identifier;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getName()
     */
    public String getName() {
        return name;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setExternalRepresentation(java.lang.String)
     */
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setIdentifier(java.lang.String)
     */
    public void setIdentifier(String ident) {
        this.identifier=ident;
        
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setName(java.lang.String)
     */
    public void setName(String name) {
        this.name=name;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getType()
     */
    public short getType() {
        return type;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setType(short)
     */
    public void setType(short type) {
        this.type=type;
    }
    
	public String[] getReferences() {
		return references;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setReferences(String[] references) {
		this.references=references;
	}


  
        
        /**
     * @return Returns the command.
     */
    public AnnotationCommandInfo getCommand() {
        return command;
    }
    /**
     * @param command The command to set.
     */
    public void setCommand(AnnotationCommandInfo command) {
        this.command = command;
    }
    /**
     * @return Returns the state.
     */
    public StateInfo getState() {
        return state;
    }
    /**
     * @param state The state to set.
     */
    public void setState(StateInfo state) {
        this.state = state;
    }
}


