/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.BackToAttributes;


/**
 * @author raf
 *
 * @
 */
public class BackToInfo extends EventInfo implements BackToAttributes  , DeltaListProvider, StateProvider, Cloneable  {
	public static final int INFO_TYPE = 4;
	public  int getInfoType() {
		return INFO_TYPE;
	}
	
	
	protected String node;
    protected String nodeBefore;
     
    protected DeltaListInfo deltaList;
    
    protected StateInfo state;
   
	public String getNode() {
		return node;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setNode(String node) {
		this.node=node;
	}
	
	public String getNodeBefore() {
		return nodeBefore;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setNodeBefore(String node) {
		this.nodeBefore=node;
	}
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.BasicInfo#clone()
     */
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        BackToInfo clone = new BackToInfo();
        clone(clone);
        clone.setNode(node);
        clone.setNodeBefore(nodeBefore);
        if (deltaList != null) clone.setDeltaList((DeltaListInfo)deltaList.clone());
        if(state != null) clone.setState((StateInfo) state.clone());
        return clone;
    }
    /**
     * @return Returns the deltaList.
     */
    public DeltaListInfo getDeltaList() {
        return deltaList;
    }
    /**
     * @param deltaList The deltaList to set.
     */
    public void setDeltaList(DeltaListInfo deltaList) {
        this.deltaList = deltaList;
    }
  
    /**
     * @return Returns the state.
     */
    public StateInfo getState() {
        return state;
    }
    /**
     * @param state The state to set.
     */
    public void setState(StateInfo state) {
        this.state = state;
    }
}