/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.FailureAttributes;


/**
 * @author raf
 *
 * @
 */
public class FailureInfo extends EventInfo implements FailureAttributes, StateProvider, ChoiceConstraintListProvider, Cloneable {
	public static final int INFO_TYPE = 18;
	public  int getInfoType() {
		return INFO_TYPE;
	}
	
	
    protected String node;
    protected String nodeName;
   
   protected StateInfo state;
   
    protected ChoiceConstraintListInfo choiceConstraintList;
 
	public String getNode() {
		return node;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setNode(String node) {
		this.node=node;
	}
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.BasicInfo#clone()
     */
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        FailureInfo clone = new FailureInfo();
        clone(clone);
        clone.setNode(node);
        if(state != null) clone.setState((StateInfo) state.clone());
        if (choiceConstraintList != null) clone.setChoiceConstraintList((ChoiceConstraintListInfo)choiceConstraintList.clone());
        return clone;
    }
	

/**
 * @return Returns the state.
 */
public StateInfo getState() {
    return state;
}
/**
 * @param state The state to set.
 */
public void setState(StateInfo state) {
    this.state = state;
}
    /**
     * @return Returns the nodeName.
     */
    public String getNodeName() {
        return nodeName;
    }
    /**
     * @param nodeName The nodeName to set.
     */
    public void setNodeName(String nodeName) {
        this.nodeName = nodeName;
    }
    /**
     * @return Returns the choiceConstraintList.
     */
    public ChoiceConstraintListInfo getChoiceConstraintList() {
        return choiceConstraintList;
    }
    /**
     * @param choiceConstraintList The choiceConstraintList to set.
     */
    public void setChoiceConstraintList(
            ChoiceConstraintListInfo choiceConstraintList) {
        this.choiceConstraintList = choiceConstraintList;
    }
}