/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.NewStageAttributes;


/**
 * @author raf
 *
 * @
 */
public class NewStageInfo extends EventInfo implements NewStageAttributes, StateProvider, StageCommentProvider,Cloneable
			 {
	public static final int INFO_TYPE = 20;
	public  int getInfoType() {
		return INFO_TYPE;
	}
	protected String identifier;
    protected String name;
    protected String[] references;
    protected String detail;
   
   protected StateInfo state;
   
   protected StageCommentInfo comment;
    
  
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.event.EventImpl#clone()
     */
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        NewStageInfo clone = new NewStageInfo();
        clone(clone);
        clone.setIdentifier(identifier);
        clone.setName(name);
        clone.setReferences(clone(references));
        clone.setDetail(detail);
 
        if(state != null) clone.setState((StateInfo) state.clone());
        if(comment != null) clone.setComment((StageCommentInfo) comment.clone());
        return clone;
    }

    /**
     * @return Returns the detail.
     */
    public String getDetail() {
        return detail;
    }
    /**
     * @param detail The detail to set.
     */
    public void setDetail(String detail) {
        this.detail = detail;
    }
    /**
     * @return Returns the identifier.
     */
    public String getIdentifier() {
        return identifier;
    }
    /**
     * @param identifier The identifier to set.
     */
    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }
    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * @return Returns the references.
     */
    public String[] getReferences() {
        return references;
    }
    /**
     * @param references The references to set.
     */
    public void setReferences(String[] references) {
        this.references = references;
    }
    /**
     * @return Returns the state.
     */
    public StateInfo getState() {
        return state;
    }
    /**
     * @param state The state to set.
     */
    public void setState(StateInfo state) {
        this.state = state;
    }
/**
 * @return Returns the comment.
 */
public StageCommentInfo getComment() {
    return comment;
}
/**
 * @param comment The comment to set.
 */
public void setComment(StageCommentInfo comment) {
    this.comment = comment;
}
    
}