/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.ReduceAttributes;


/**
 * @author raf
 *
 * @
 */
public class ReduceInfo extends EventInfo implements ReduceAttributes, 
		UpdateProvider, StateProvider, DeltaProvider, VarDomainProvider, ExplanationListProvider, Cloneable {
	public static final int INFO_TYPE = 25;
	public  int getInfoType() {
		return INFO_TYPE;
	}
    protected String variable;
    protected String constraint;
    protected String algorithm;
     
    protected UpdateInfo update;
    
    protected StateInfo state;

    protected VarDomainInfo varDomain;;
    
    protected DeltaInfo delta;
    
    protected ExplanationListInfo explanationList;
 
	public String getVariable() {
		return variable;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setVariable(String var) {
		this.variable=var;
	}
	
	public String getConstraint() {
		return constraint;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setConstraint(String cst) {
		this.constraint=cst;
	}
	
	public String getAlgorithm() {
		return algorithm;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent#setOrigin(java.lang.String)
	 */
	public void setAlgorithm(String algo) {
		this.algorithm=algo;
	}
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.info.BasicInfo#clone()
     */
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        ReduceInfo clone = new ReduceInfo();
        clone(clone);
        clone.setVariable(variable);
        clone.setConstraint(constraint);
        clone.setAlgorithm(algorithm);
        if (update != null) clone.setUpdate((UpdateInfo)update.clone());
        if(varDomain != null) clone.setVarDomain((VarDomainInfo) varDomain.clone());
        if(delta != null) clone.setDelta((DeltaInfo) delta.clone());
        if(explanationList != null) clone.setExplanationList((ExplanationListInfo) explanationList.clone());
        if(state != null) clone.setState((StateInfo) state.clone());
        return clone;
    }

    /**
     * @return Returns the update.
     */
    public UpdateInfo getUpdate() {
        return update;
    }
    /**
     * @param update The update to set.
     */
    public void setUpdate(UpdateInfo update) {
        this.update = update;
    }
    /**
     * @return Returns the state.
     */
    public StateInfo getState() {
        return state;
    }
    /**
     * @param state The state to set.
     */
    public void setState(StateInfo state) {
        this.state = state;
    }
    /**
     * @return Returns the delta.
     */
    public DeltaInfo getDelta() {
        return delta;
    }
    /**
     * @param delta The delta to set.
     */
    public void setDelta(DeltaInfo delta) {
        this.delta = delta;
    }
    /**
     * @return Returns the varDomain.
     */
    public VarDomainInfo getVarDomain() {
        return varDomain;
    }
    /**
     * @param varDomain The varDomain to set.
     */
    public void setVarDomain(VarDomainInfo varDomain) {
        this.varDomain = varDomain;
    }

	/**
	 * @return Returns the explanationList.
	 */
	public ExplanationListInfo getExplanationList() {
		return explanationList;
	}
	/**
	 * @param explanationList The explanationList to set.
	 */
	public void setExplanationList(ExplanationListInfo explanationList) {
		this.explanationList = explanationList;
	}
}