/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 11 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.parsing.info;

import fr.inria.oadymppac.parsing.gentra4cp.event.attributes.VariableAttributes;


/**
 * @author raf
 *
 * @
 */
public class VariableInfo extends BasicInfo implements VariableAttributes, ValueListProvider, VarDomainProvider, Cloneable {
	
	public static final int INFO_TYPE = 44;
	public  int getInfoType() {
		return INFO_TYPE;
	}
    protected String identifier;
    protected String name;
    protected String external;
    protected String internal;
    protected short   type;
 
    
    
    protected ValueListInfo valueList;
    
    protected VarDomainInfo varDomain;
    
    public Object clone() throws CloneNotSupportedException {
    	super.clone();
        VariableInfo clone = new VariableInfo();
        clone.setIdentifier(identifier);
        clone.setName(name);
        clone.setInternal(internal);
        clone.setExternal(external);
        if(valueList != null) clone.setValueList((ValueListInfo) valueList.clone());
        if(varDomain !=null) clone.setVarDomain((VarDomainInfo) varDomain.clone());
        return clone;
    } 
   
    
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getExternalRepresentation()
     */
    public String getExternal() {
        return external;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getIdentifier()
     */
    public String getIdentifier() {
        return identifier;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getInternalRepresentation()
     */
    public String getInternal() {
        return internal;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getName()
     */
    public String getName() {
        return name;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setExternalRepresentation(java.lang.String)
     */
    public void setExternal(String external) {
        this.external=external;
        
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setIdentifier(java.lang.String)
     */
    public void setIdentifier(String ident) {
        this.identifier=ident;
        
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setInternalRepresentation(java.lang.String)
     */
    public void setInternal(String internal) {
        this.internal=internal;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setName(java.lang.String)
     */
    public void setName(String name) {
        this.name=name;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#getType()
     */
    public short getType() {
        return type;
    }
    /* (non-Javadoc)
     * @see fr.inria.oadymppac.parsing.gentra4cp.event.attributes.DTDVariableAttributes#setType(short)
     */
    public void setType(short type) {
        this.type=type;
    }
    
    
  

    /**
     * @return Returns the valueList.
     */
    public ValueListInfo getValueList() {
        return valueList;
    }
    /**
     * @param valueList The valueList to set.
     */
    public void setValueList(ValueListInfo valueList) {
        this.valueList = valueList;
    }
    /**
     * @return Returns the varDomain.
     */
    public VarDomainInfo getVarDomain() {
        return varDomain;
    }
    /**
     * @param varDomain The varDomain to set.
     */
    public void setVarDomain(VarDomainInfo varDomain) {
        this.varDomain = varDomain;
    }
}