/*
 * Created on 13 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver;

import java.util.Collection;
import java.util.Vector;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultConstraint extends AbstractConstraint implements Constraint {
	
	
	
	protected String internal;
	protected String external;
	protected String name;
	protected String origin;

	protected Collection variables;
	protected Collection updates;
	
	protected State state;
	
	/**
	 * @param solver
	 */
	public DefaultConstraint(Solver solver) {
		super(solver);
	}
	
	/**
	 * @return Returns the external.
	 */
	public String getExternal() {
		return external;
	}
	/**
	 * @param external The external to set.
	 */
	public void setExternal(String external) {
		this.external = external;
	}
	
	/**
	 * @return Returns the internal.
	 */
	public String getInternal() {
		return internal;
	}
	/**
	 * @param internal The internal to set.
	 */
	public void setInternal(String internal) {
		this.internal = internal;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	protected void buildVariables() {
		if (variables == null) variables = new Vector();
	}
	/**
	 * @return Returns the variables.
	 */
	public Collection getVariables() {
		return variables;
	}
	/**
	 * @param variables The variables to set.
	 */
	public void setVariables(Collection vars) {
		buildVariables();
		this.variables.clear();
		this.variables.addAll(vars);
	}
	
	
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#addConstraint(int)
	 */
	public void addVariable(Variable variable) {
		buildVariables();
		if (!variables.contains(variable)) variables.add(variable);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#clearVariables()
	 */
	public void clearVariables() {
		variables.clear();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#countConstraint()
	 */
	public int countVariables() {
		return variables.size();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#removeConstraint(int)
	 */
	public void removeVariable(Variable variable) {
		variables.remove(variable);
	}
	
	
	protected void buildUpdates() {
		if (updates == null) updates = new Vector();
	}
	/**
	 * @return Returns the updates.
	 */
	public Collection getUpdates() {
		return updates;
	}
	/**
	 * @param updates The updates to set.
	 */
	public void setUpdates(Collection updts) {
		buildUpdates();
		this.updates.clear();
		this.updates.addAll(updts);
	}
	
	
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Update#addConstraint(int)
	 */
	public void addUpdate(Update update) {
		buildUpdates();
		if (!updates.contains(update)) updates.add(update);
		
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Update#clearUpdates()
	 */
	public void clearUpdates() {
		updates.clear();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Update#countConstraint()
	 */
	public int countUpdates() {
		return updates.size();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Update#removeConstraint(int)
	 */
	public void removeUpdate(Update update) {
		updates.remove(update);
	}
	
	
	
	
	
	
	public String toString() {
		StringBuffer buffer = new StringBuffer("CONSTRAINT "+index+":[ ");
		buffer.append("ident="+identifier+" ");
		buffer.append("name="+name+" ");
		buffer.append("internal="+internal+" ");
		buffer.append("external="+external+" ");
		buffer.append(super.toString());
		buffer.append("]");
		return buffer.toString();
		}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getLabel()
	 */
	public String getLabel() {
		return getName();
	}
	
	
	
	/**
	 * @return Returns the origin.
	 */
	public synchronized String getOrigin() {
		return origin;
	}
	/**
	 * @param origin The origin to set.
	 */
	public synchronized void setOrigin(String origin) {
		this.origin = origin;
	}
	/**
	 * @return Returns the state.
	 */
	public synchronized State getState() {
		return state;
	}
	/**
	 * @param state The state to set.
	 */
	public synchronized void setState(State state) {
		this.state = state;
	}
}
