/*
 * Created on 13 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver;

import java.util.Collection;
import java.util.Comparator;
import java.util.Vector;

import fr.inria.oadymppac.utils.SortedVector;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultVariable extends AbstractVariable implements Variable {
	
	private Comparator depthComparator;
	private Comparator chronoComparator;
	
	protected String internal;
	protected String external;
	protected String name;
	protected short type;
	protected State state;
	

	protected Vector constraints;

	
	protected Domain initialDomain;
	protected Domain currentDomain;
	protected Domain previousDomain; // keep track of the two last domain to quckly perform estimate reduction
	protected Collection domainChrono;
	protected Collection domainDepth;
	
	protected Delta currentDelta;
	protected Delta previousDelta; // keep track of the two last domain to quckly perform estimate reduction
	protected Collection deltaChrono;
	protected Collection deltaDepth;
	
	/**
	 * @param solver
	 */
	public DefaultVariable(Solver solver) {
		super(solver);
	}
	
	/**
	 * @return Returns the external.
	 */
	public String getExternal() {
		return external;
	}
	/**
	 * @param external The external to set.
	 */
	public void setExternal(String external) {
		this.external = external;
	}
	
	/**
	 * @return Returns the internal.
	 */
	public String getInternal() {
		return internal;
	}
	/**
	 * @param internal The internal to set.
	 */
	public void setInternal(String internal) {
		this.internal = internal;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	
	
	protected void buildConstraints() {
		if (constraints == null) this.constraints = new Vector();
	}
	
	protected void buildDomains() {
		if (depthComparator == null) depthComparator = new DepthComparator();
		if (domainDepth == null) this.domainDepth = new SortedVector(depthComparator);
		if (chronoComparator == null) chronoComparator = new ChronoComparator();
		if (domainChrono == null) this.domainChrono = new SortedVector(chronoComparator);
	}
	
	protected void buildDeltas() {
		if (depthComparator == null) depthComparator = new DepthComparator();
		if (deltaDepth == null) this.deltaDepth = new SortedVector(depthComparator);
		if (chronoComparator == null) chronoComparator = new ChronoComparator();
		if (deltaChrono == null) this.deltaChrono = new SortedVector(chronoComparator);
	}
	
	/**
	 * @return Returns the constraints.
	 */
	public Collection getConstraints() {
		return constraints;
	}
	/**
	 * @param constraints The constraints to set.
	 */
	public void setConstraints(Collection constraints) {
		buildConstraints();
		constraints.clear();
		this.constraints.addAll(constraints);
	}
	
	
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#addConstraint(int)
	 */
	public void addConstraint(Constraint constraint) {
		buildConstraints();
		if (!constraints.contains(constraint)) constraints.add(constraint);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#clearConstraints()
	 */
	public void clearConstraints() {
		if (constraints != null) constraints.clear();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#countConstraint()
	 */
	public int countConstraints() {
		return (constraints == null ? 0 : constraints.size());
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#removeConstraint(int)
	 */
	public void removeConstraint(Constraint constraint) {
		if (constraints != null) constraints.remove(constraint);
	}
	
	public String toString() {
	StringBuffer buffer = new StringBuffer("VARIABLE "+index+":[ ");
	buffer.append("ident="+identifier+" ");
	buffer.append("name="+name+" ");
	buffer.append("internal="+internal+" ");
	buffer.append("external="+external+" ");
	buffer.append(super.toString());
	buffer.append("]");
	return buffer.toString();
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.SolverElement#getLabel()
	 */
	public String getLabel() {
		return getName();
	}
	
	
	/**
	 * @return Returns the initialDomain.
	 */
	public synchronized Domain getInitialDomain() {
		return initialDomain;
	}
	
	/**
	 * @return Returns the type.
	 */
	public synchronized short getType() {
		return type;
	}
	/**
	 * @param type The type to set.
	 */
	public synchronized void setType(short type) {
		this.type = type;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getDomainAtChrono(int)
	 */
	public Domain getDomainAtChrono(int ch) {
		return null;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getDomainAtDepth(int)
	 */
	public Domain getDomainAtDepth(int d) {
		return null;
	}
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getDomainAtChrono(int)
	 */
	public Delta getDeltaAtChrono(int ch) {
		return null;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getDomainAtDepth(int)
	 */
	public Delta getDeltaAtDepth(int d) {
		return null;
	}
	
	/**
	 * @return Returns the state.
	 */
	public synchronized State getState() {
		return state;
	}
	/**
	 * @param state The state to set.
	 */
	public synchronized void setState(State state) {
		this.state = state;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#addDomain(fr.inria.oadymppac.solver.Domain)
	 */
	public void addDomain(Domain domain) {
		DefaultDomain.DomainKey key = (DefaultDomain.DomainKey) domain.getKey();
		if (key.getIndex() < 0) {
			key.setIndex(solver.getIntValue(Solver.CURRENT_CHRONO));
		}
		if (key.getVariable() == null) {
			key.setVariable(this);
		}
		solver.add(Solver.DOMAIN,domain);
		buildDomains();
//		domainDepth.add(domain);
//		domainChrono.add(domain);
		if (initialDomain == null) {
			initialDomain = domain;
		} else {
			previousDomain = currentDomain;
		}
		currentDomain = domain;
		
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getCurrentDomain()
	 */
	public Domain getCurrentDomain() {
		return currentDomain;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getPreviousDomain()
	 */
	public Domain getPreviousDomain() {
		return previousDomain;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#addDomain(fr.inria.oadymppac.solver.Domain)
	 */
	public void addDelta(Delta delta) {
		DefaultDelta.DeltaKey key = (DefaultDelta.DeltaKey) delta.getKey();
		if (key.getIndex() < 0) {
			key.setIndex(solver.getIntValue(Solver.CURRENT_CHRONO));
		}
		if (key.getVariable() == null) {
			key.setVariable(this);
		}
		solver.add(Solver.DELTA,delta);
		buildDeltas();
//		deltaDepth.add(delta);
//		deltaChrono.add(delta);
		previousDelta = currentDelta;
		currentDelta = delta;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getCurrentDomain()
	 */
	public Delta getCurrentDelta() {
		return currentDelta;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.Variable#getPreviousDomain()
	 */
	public Delta getPreviousDelta() {
		return previousDelta;
	}
}
