/*
 * $Id: Explanation.java,v 1.7 2004/05/28 06:28:47 raf Exp $
 *
 * Copyright (c) 2001-2002 Jean-Daniel Fekete, Mohammad Ghoniem and
 * Ecole des Mines de Nantes.  All rights reserved.
 *
 * This software is proprietary information of Jean-Daniel Fekete and
 * Ecole des Mines de Nantes.  You shall use it only in accordance
 * with the terms of the license agreement you accepted when
 * downloading this software.  The license is available in the file
 * licence.txt and at the following URL:
 * http://www.emn.fr/fekete/oadymppac/licence.html
 */
package fr.inria.oadymppac.solver;

import java.util.Collection;

/**
 * An <code>Explanation</code> consists of a cause list and a contraint list.
 *
 * @author Jean-Daniel Fekete
 * @author Mohammad Ghoniem
 * @version $Revision: 1.7 $
 */

public interface Explanation extends SolverElement, ConstraintCollection 
{
	public static final String EVENT_TYPE="EXPLANATION";
    public Reduce getReduce();
    public void setReduce(Reduce reduce);
    
    public ValueList getValueList();
    public void setValueList(ValueList valueList);

    public Collection getCauses();
    public void setCauses(Collection cause);
    public void addCause(Cause cause);
    public void removeCause(Cause cause);
    public int countCause();
    public void clearCause();
    
    
    
    
}
