/*
 * $Id: OrderedManager.java,v 1.3 2004/05/28 06:28:48 raf Exp $
 *
 * Copyright (c) 2001-2002 Jean-Daniel Fekete, Mohammad Ghoniem and
 * Ecole des Mines de Nantes.  All rights reserved.
 *
 * This software is proprietary information of Jean-Daniel Fekete and
 * Ecole des Mines de Nantes.  You shall use it only in accordance
 * with the terms of the license agreement you accepted when
 * downloading this software.  The license is available in the file
 * licence.txt and at the following URL:
 * http://www.emn.fr/fekete/oadymppac/licence.html
 */
package fr.inria.oadymppac.solver;

import java.util.Map;
import java.util.TreeMap;

/**
 * A <code>VariableManager</code> is a utility class that manages the
 * domain of all the variables declared and used during a session.  It
 * keeps track of the domains and notifies listeners when the domains
 * change.
 *
 * @author Jean-Daniel Fekete
 * @author Mohammad Ghoniem
 * @version $Revision: 1.3 $
 */
public abstract class OrderedManager extends SolverObjectManager  {

	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.utils.ObjectManager#buildIndexer()
	 */
	protected Map buildIndexer() {
		return new TreeMap();
	}
	
}
