/*
 * Created on 20 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.analyser;

import java.util.Iterator;

import org.apache.log4j.Logger;

import fr.inria.oadymppac.solver.Awake;
import fr.inria.oadymppac.solver.Constraint;
import fr.inria.oadymppac.solver.Reduce;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverElement;
import fr.inria.oadymppac.solver.SolverManagable;
import fr.inria.oadymppac.solver.SolverTypes;
import fr.inria.oadymppac.solver.Variable;
import fr.inria.oadymppac.utils.ObjectManager;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class SolverAnalyserImpl implements SolverAnalyser, SolverManagable, SolverTypes {
	public static final Logger logger = Logger.getLogger(SolverAnalyser.class);
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.analyser.SolverAnalyser#analyse()
	 */
	Solver solver;
	
	
	/**
	 * @return Returns the solver.
	 */
	public Solver getSolver() {
		return solver;
	}
	/**
	 * @param solver The solver to set.
	 */
	public void setSolver(Solver solver) {
		this.solver = solver;
	}
	/**
	 * 
	 */
	public SolverAnalyserImpl(Solver solver) {
		setSolver(solver);
		
	}
	
	
	public void analyse() {
		if (solver != null) {
			ObjectManager manager;
			Iterator it;
			int [] types = getAnalyseTypes();
			for(int i=0; i < types.length; i++) {
				manager = (ObjectManager) solver.get(types[i]);
				it = (manager == null ? null : manager.iterator());
				while (it != null && it.hasNext()){
					addToAnalysis((SolverElement)it.next());
				}
			}
			endAnalyse();
		} else {
			logger.info("No data to analyse");
		}
	}
	
	protected abstract int[] getAnalyseTypes();
	
	
	protected void addToAnalysis(SolverElement elem) {
		int type = elem.getSolverType();
		switch (type) {
			case EXCEPTION :
				solver.add(EXCEPTION, (Exception) elem);
				break;
		    case VARIABLE:
		    	add((Variable) elem);
		    	break;
		    case CONSTRAINT:
		    	add((Constraint) elem);
		    	break;
		    case POST:
		    	break;
		    case SEARCHNODE:
		    	break;
		    case BACKTO:
		    	break;
		    case REMOVE	:
		    	break;
		    case RESTORE:
		    	break;
		    case REDUCE	:
		    	add((Reduce) elem);
		    case SUSPEND:
		    	break;
		    case SOLVED	:
		    	break;
		    case REJECT	:
		    	break;
		    case AWAKE	:
		    	add((Awake) elem);
		    	break;
		    case SCHEDULE:
		    	break;
		    case ANNOTATION	:
		    	break;
		    case STAGE:
		    	break;
		    case STAGE_EVENT	:
		    	break;
		    case STATE	:	
		    	break;
		    default:
		    	break;
		}
	}
	
	public void add(Variable variable) {};
	public void add(Constraint constraint) {};
	public void add(Reduce reduce) {};
	public void add(Awake awake) {};

	
	
	
}
