/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 17 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.solver.parsing;

import fr.inria.oadymppac.parsing.event.EventListenerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.event.AnnotationEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.AwakeEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.BackToEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ChoicePointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.EndStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.FailureEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewConstraintEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.PostEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ReduceEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RejectEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RemoveEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.RestoreEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ResumeStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.ScheduleEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolutionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SolvedEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StartStageEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.StateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.SuspendStageEvent;
import fr.inria.oadymppac.parsing.info.AnnotationInfo;
import fr.inria.oadymppac.parsing.info.ChoicePointInfo;
import fr.inria.oadymppac.parsing.info.EventInfo;
import fr.inria.oadymppac.parsing.info.FailureInfo;
import fr.inria.oadymppac.parsing.info.NewConstraintInfo;
import fr.inria.oadymppac.parsing.info.NewStageInfo;
import fr.inria.oadymppac.parsing.info.NewVariableInfo;
import fr.inria.oadymppac.parsing.info.SolutionInfo;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverTypes;
import fr.inria.oadymppac.solver.SolverManagable;

/**
 * @author raf
 *  @
 */
public class AbstractManagerEventListener extends EventListenerImpl implements SolverManagable,SolverTypes {
	
	protected Solver solver;
	
	protected int[] countTag = new int[EVENT_SIZE];
	
	
	
	
	
    public void eventProcess(NewVariableEvent ev) {
    	countTag[VARIABLE]++;
    }

    
    
    public void eventProcess(NewConstraintEvent ev) {
    	countTag[CONSTRAINT]++;
    }
    
    

    public void eventProcess(PostEvent ev) {
    	countTag[POST]++;
    }

    public void eventProcess(ChoicePointEvent ev) {
    	countTag[SEARCHNODE]++;;
    }

    public void eventProcess(SolutionEvent ev) {
    	countTag[SEARCHNODE]++;;
    }

    public void eventProcess(FailureEvent ev) {
    	countTag[SEARCHNODE]++;;
    }

    public void eventProcess(BackToEvent ev) {
    	countTag[BACKTO]++;;
    }

    public void eventProcess(ReduceEvent ev) {
    	countTag[REDUCE]++;;
    }

    public void eventProcess(AwakeEvent ev) {
    	countTag[AWAKE]++;;
    }

    public void eventProcess(ScheduleEvent ev) {
    	countTag[SCHEDULE]++;;
    }

    public void eventProcess(RemoveEvent ev) {
    	countTag[REMOVE]++;;
    }

    public void eventProcess(RestoreEvent ev) {
    	countTag[RESTORE]++;;
    }

    public void eventProcess(SuspendEvent ev) {
    	countTag[SUSPEND]++;;
    }

    public void eventProcess(SolvedEvent ev) {
    	countTag[SOLVED]++;;
    }

    public void eventProcess(RejectEvent ev) {
    	countTag[REJECT]++;;
    }

    public void eventProcess(AnnotationEvent ev) {
    	countTag[ANNOTATION]++;
    }

    public void eventProcess(NewStageEvent ev) {
    	countTag[STAGE]++;
    }
    
    public void eventProcess(StartStageEvent ev) {
    	countTag[STAGE_EVENT]++;
    }
    
    public void eventProcess(SuspendStageEvent ev) {
    	countTag[STAGE_EVENT]++;
    }
    
    public void eventProcess(ResumeStageEvent ev) {
    	countTag[STAGE_EVENT]++;
    }
    
    public void eventProcess(EndStageEvent ev) {
    	countTag[STAGE_EVENT]++;
    }
    
    public void eventProcess(StateEvent ev) {
    	countTag[STATE]++;
    }

    
    
	/**
	 * @return Returns the solver.
	 */
	public Solver getSolver() {
		return solver;
	}
	/**
	 * @param solver The solver to set.
	 */
	public void setSolver(Solver solver) {
		this.solver = solver;
	}
	/**
	 * 
	 */
	public AbstractManagerEventListener(Solver solver) {
		setSolver(solver);
	}
	
	/**
	 * @return Returns the annotation.
	 */
	public synchronized int getAnnotation() {
		return countTag[ANNOTATION];
	}
	/**
	 * @return Returns the awake.
	 */
	public synchronized int getAwake() {
		return countTag[AWAKE];
	}
	/**
	 * @return Returns the backTo.
	 */
	public synchronized int getBackTo() {
		return countTag[BACKTO];
	}
	/**
	 * @return Returns the choicePoint.
	 */
	public synchronized int getChoicePoint() {
		return countTag[SEARCHNODE];
	}
	/**
	 * @return Returns the failure.
	 */
	public synchronized int getFailure() {
		return countTag[SEARCHNODE];
	}
	/**
	 * @return Returns the newConstraint.
	 */
	public synchronized int getNewConstraint() {
		return countTag[CONSTRAINT];
	}
	/**
	 * @return Returns the newVariable.
	 */
	public synchronized int getNewVariable() {
		return countTag[VARIABLE];
	}
	/**
	 * @return Returns the post.
	 */
	public synchronized int getPost() {
		return countTag[POST];
	}
	/**
	 * @return Returns the reduce.
	 */
	public synchronized int getReduce() {
		return countTag[REDUCE];
	}
	/**
	 * @return Returns the reject.
	 */
	public synchronized int getReject() {
		return countTag[REJECT];
	}
	/**
	 * @return Returns the remove.
	 */
	public synchronized int getRemove() {
		return countTag[REMOVE];
	}
	/**
	 * @return Returns the restore.
	 */
	public synchronized int getRestore() {
		return countTag[RESTORE];
	}
	/**
	 * @return Returns the schedule.
	 */
	public synchronized int getSchedule() {
		return countTag[SCHEDULE];
	}
	/**
	 * @return Returns the solution.
	 */
	public synchronized int getSolution() {
		return countTag[SEARCHNODE];
	}
	/**
	 * @return Returns the solved.
	 */
	public synchronized int getSolved() {
		return countTag[SOLVED];
	}
	/**
	 * @return Returns the state.
	 */
	public synchronized int getState() {
		return countTag[STATE];
	}
	/**
	 * @return Returns the suspend.
	 */
	public synchronized int getSuspend() {
		return countTag[SUSPEND];
	}
	
	public String extractVariableIdentifier(String identifier) {
		return ((identifier==NewVariableInfo.IDENTIFIER_NONE  ? "VAR"+countTag[VARIABLE] : identifier));
    }
	
	public String extractConstraintIdentifier(String identifier) {
		return ((identifier==NewConstraintInfo.IDENTIFIER_NONE  ? "CTR"+countTag[CONSTRAINT] : identifier));
    }
	
	public String extractChoicePointIdentifier(String identifier) {
		return ((identifier==ChoicePointInfo.NODE_NONE  ? "CHOICE"+countTag[SEARCHNODE] : identifier));
    }
	
	public String extractSolutionIdentifier(String identifier) {
		return ((identifier==SolutionInfo.NODE_NONE  ? "SOL"+countTag[SEARCHNODE] : identifier));
    }
	
	public String extractFailureIdentifier(String identifier) {
		return ((identifier==FailureInfo.NODE_NONE  ? "FAIL"+countTag[SEARCHNODE] : identifier));
    }
	
	public String extractAnnotationIdentifier(String identifier) {
		return ((identifier==AnnotationInfo.IDENTIFIER_NONE  ? "ANNO"+countTag[ANNOTATION] : identifier));
    }
	
	public String extractStageIdentifier(String identifier) {
		return ((identifier==NewStageInfo.IDENTIFIER_NONE  ? "STAGE"+countTag[STAGE] : identifier));
    }
	
	public int extractEventIdentifier(int event, int identifier) {
		return ((identifier==EventInfo.CHRONO_NONE  ? countTag[event] : identifier));
    }
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processEnd()
	 */
	public void processEnd() {
		super.processEnd();
	};
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processInstruction(java.lang.String, java.lang.String)
	 */
	public void processInstruction(String target, String data) {
		super.processInstruction(target, data);
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.parsing.event.EventListener#processStart()
	 */
	public void processStart() {
		for(int i=0; i < countTag.length; i++) {
			countTag[i] = 0;
		}
	}
}
