/*
 * INRIA-OADYMPPAC
 * 
 * Ownership: Copyright (c) 1990-2004 COSYTEC S.A.
 * Author	: 	raf
 *           	COSYTEC
 *		    	4 rue Jean Rostand
 * 				91893 Orsay Cedex, France
 *				Tel. +33 1 60 19 37 38
 *				Fax. +33 1 60 19 36 20
 *
 * Purpose	: COMPLETE HERE
 * 
 * Created on 17 mars 2004
 *
 * 
 */
package fr.inria.oadymppac.solver.parsing;

import fr.inria.oadymppac.parsing.event.EventListenerImpl;
import fr.inria.oadymppac.parsing.gentra4cp.HeadEventListener;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ChecksumEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ContributorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.CreatorEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DateEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.DescriptionEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.IdentifierEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.ParametersEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.RightsEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.SolverEvent;
import fr.inria.oadymppac.parsing.gentra4cp.event.header.SourceEvent;


/**
 * @author raf
 *
 * @
 */
public class SingleHeadEventListener extends EventListenerImpl implements HeadEventListener {

        /* (non-Javadoc)
* @see fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEventListener#eventReceived(fr.inria.oadymppac.parsing.gentra4cp.event.NewVariableEvent)
*/

        public void eventProcess(DateEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Date event:"+ev.getDate());
        }
        
        public void eventProcess(SourceEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Source event:"+ev.getSource());
        } 

        public void eventProcess(CreatorEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Creator event:"+ev.getCreator());
        } 

        public void eventProcess(ContributorEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Contributor event:"+ev.getContributor());
        } 
        
        public void eventProcess(DescriptionEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Description event:"+ev.getDescription());
        } 

        public void eventProcess(IdentifierEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Identifier event:"+ev.getIdentifier());
        } 

        public void eventProcess(RightsEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Rights event:"+ev.getRights());
        } 

        public void eventProcess(SolverEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Solver event:"+ev.getSolver());
        } 

        public void eventProcess(ParametersEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Parameters event:"+ev.getParameters());
        } 
        
        public void eventProcess(ChecksumEvent ev) {
            if (logger.isDebugEnabled()) logger.info("Processing a Checksum event:"+ev.getChecksum());
        } 

    }

