/*
 * Created on 4 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import java.util.Collection;
import java.util.Iterator;

import fr.inria.oadymppac.parsing.info.CauseInfo;
import fr.inria.oadymppac.parsing.info.CauseListInfo;
import fr.inria.oadymppac.parsing.info.RangeInfo;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.ValuesInfo;
import fr.inria.oadymppac.solver.Cause;
import fr.inria.oadymppac.solver.DefaultCause;
import fr.inria.oadymppac.solver.Explanation;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.Variable;
import fr.inria.oadymppac.solver.VariableManager;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultCauseAdapter extends DefaultAdapter
		implements
			CauseAdapter {
	/**
	 * @param solver
	 */
	public DefaultCauseAdapter(Solver solver) {
		super(solver);
	}
	
	
	public void adapt(CauseListInfo info, Explanation element)
	throws SolverException {
		
		Collection causes = (info == null ? null : info.getInfo());
		Iterator it = (causes == null ? null : causes.iterator());
		CauseInfo cs;
		Cause cause;
		while (it != null && it.hasNext() ) {
			cs = (CauseInfo) it.next();
			cause = new DefaultCause(solver);
			adapt(cs,cause);
			cause.setExplanation(element);
			element.addCause(cause);
		}
		
	}
	
	
	
	public void adapt(CauseInfo info, Cause element) throws SolverException{
		element.setType(info.getType());
		int var = solver.get(Solver.VARIABLE, info.getVariable());
		if (var != VariableManager.INVALID) {
			Variable variable = (Variable) solver.get(Solver.VARIABLE, var);
			element.setVariable(variable);
		}
		adapt(info.getValueList(), element);
	}
	
	
	public void adapt(ValueListInfo info, Cause element) throws SolverException{
		Iterator it = (info == null ? null : info.iterator());
		Object part = null;
		RangeInfo range = null;
		ValuesInfo values = null;
		int[] temp=null;
		while (it != null && it.hasNext()) {
			part = it.next();
			if (part != null && part instanceof RangeInfo) {
				range = (RangeInfo) part;
				element.add(range.getFrom(), range.getTo());		
			} else if (part != null && part instanceof ValuesInfo) {
				values = (ValuesInfo) part;
				temp = values.getValues();
				for(int i=0; i < temp.length; i++) {
					element.add(temp[i], temp[i]);
				}
			} else {
				throw new SolverException("INVALID VALUE LIST DEFINITION");
			}
		}
	}
}
