/*
 * Created on 6 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import java.util.Collection;
import java.util.Iterator;

import fr.inria.oadymppac.parsing.info.ExplanationInfo;
import fr.inria.oadymppac.parsing.info.ExplanationListInfo;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.solver.DefaultExplanation;
import fr.inria.oadymppac.solver.DefaultValueList;
import fr.inria.oadymppac.solver.Explanation;
import fr.inria.oadymppac.solver.Reduce;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.ValueList;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultExplanationAdapter extends DefaultAdapter
		implements
			ExplanationAdapter {
	
	private CauseAdapter causeAdapter;
	private ValueListAdapter valueListAdapter;

	/**
	 * @param solver
	 */
	public DefaultExplanationAdapter(Solver solver) {
		super(solver);
	}
	
	
	
	
	/**
	 * @return Returns the causeAdapter.
	 */
	public synchronized CauseAdapter getCauseAdapter() {
		return causeAdapter;
	}
	/**
	 * @param causeAdapter The causeAdapter to set.
	 */
	public synchronized void setCauseAdapter(CauseAdapter causeAdapter) {
		this.causeAdapter = causeAdapter;
	}
	/**
	 * @return Returns the valueListAdapter.
	 */
	public synchronized ValueListAdapter getValueListAdapter() {
		return valueListAdapter;
	}
	/**
	 * @param valueListAdapter The valueListAdapter to set.
	 */
	public synchronized void setValueListAdapter(
			ValueListAdapter valueListAdapter) {
		this.valueListAdapter = valueListAdapter;
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.parsing.adapter.AbstractAdapter#adapt(fr.inria.oadymppac.parsing.info.CauseListInfo, fr.inria.oadymppac.solver.Explanation)
	 */
	
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.parsing.adapter.AbstractAdapter#adapt(fr.inria.oadymppac.parsing.info.ExplanationInfo, fr.inria.oadymppac.solver.Explanation)
	 */
	public void adapt(ExplanationInfo info, Explanation element)
			throws SolverException {
		ValueListInfo vals = info.getValueList();
		if (valueListAdapter != null && vals != null) {
			ValueList valueList = new DefaultValueList(solver);
			valueListAdapter.adapt( vals, valueList);
			element.setValueList(valueList);
		}
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.parsing.adapter.AbstractAdapter#adapt(fr.inria.oadymppac.parsing.info.ExplanationListInfo, fr.inria.oadymppac.solver.Reduce)
	 */
	public void adapt(ExplanationListInfo info, Reduce element)
			throws SolverException {
		Collection explanations = (info == null ? null : info.getInfo());
		Iterator it = (explanations == null ? null : explanations.iterator());
		Explanation explanation;
		ExplanationInfo expl;
		while (it != null && it.hasNext()) {
			expl = (ExplanationInfo) it.next();
			explanation = new DefaultExplanation(solver);
			adapt(expl, explanation);
			element.addExplanation(explanation);
			explanation.setReduce(element);
		}
	}
	/* (non-Javadoc)
	 * @see fr.inria.oadymppac.solver.parsing.adapter.AbstractAdapter#adapt(fr.inria.oadymppac.parsing.info.ValueListInfo, fr.inria.oadymppac.solver.ValueList)
	 */
	public void adapt(ValueListInfo info, Explanation element)
			throws SolverException {
		ValueList valueList = new DefaultValueList(solver);
		if (valueListAdapter != null) valueListAdapter.adapt(info,valueList);
		element.setValueList(valueList);
		
	}
}
