/*
 * Created on 3 mai 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.solver.parsing.adapter;

import fr.inria.oadymppac.parsing.info.EventInfo;
import fr.inria.oadymppac.parsing.info.NewVariableInfo;
import fr.inria.oadymppac.parsing.info.StateInfo;
import fr.inria.oadymppac.parsing.info.ValueListInfo;
import fr.inria.oadymppac.parsing.info.VarDomainInfo;
import fr.inria.oadymppac.solver.DefaultDomain;
import fr.inria.oadymppac.solver.DefaultState;
import fr.inria.oadymppac.solver.Domain;
import fr.inria.oadymppac.solver.Solver;
import fr.inria.oadymppac.solver.SolverException;
import fr.inria.oadymppac.solver.SolverMainElement;
import fr.inria.oadymppac.solver.State;
import fr.inria.oadymppac.solver.Variable;
import fr.inria.oadymppac.solver.VariableManager;
import fr.inria.oadymppac.solver.VariableProxy;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DefaultVariableAdapter extends DefaultAdapter implements VariableAdapter {
	/**
	 * @param solver
	 */
	
	private String buffer;
	
	protected DomainAdapter domainAdapter;
	protected StateAdapter stateAdapter;
	
	public DefaultVariableAdapter(Solver solver) {
		super(solver);
	}
	
	public  void  adapt(NewVariableInfo info, Variable element) throws SolverException {
		adaptEvent((EventInfo)info, (SolverMainElement) element);
		element.setIdentifier(info.getIdentifier());
		buffer = info.getExternal();  		
		element.setExternal(buffer==NewVariableInfo.EXTERNAL_NONE ? NONE : buffer);
		buffer = info.getInternal(); 
		element.setInternal(buffer==NewVariableInfo.INTERNAL_NONE ? NONE : buffer);
		buffer = info.getName(); 
		buffer = (buffer==NewVariableInfo.NAME_NONE ? element.getExternal() : buffer);
		buffer = (buffer==NONE ? element.getInternal() : buffer);
		buffer = (buffer==NONE ? element.getIdentifier() : buffer);
		element.setName(buffer);
		String varId = info.getIdentifier();
		if (varId.equals(NewVariableInfo.IDENTIFIER_NONE)) {
			throw new SolverException("INVALID CONSTRAINT IDENTIFIER AT "+info.getChrono());
		} else {
			int var = solver.get(Solver.VARIABLE, varId);
			if (var != VariableManager.INVALID) {
				VariableProxy proxy= (VariableProxy) solver.get(Solver.VARIABLE, var);
				if (proxy != null) proxy.setProxy(element);
			} else {
				solver.add(Solver.VARIABLE, element);
			}
		}
		int min= VarDomainInfo.MIN_NONE;
		int max=VarDomainInfo.MAX_NONE;
		int size=VarDomainInfo.SIZE_NONE;
		VarDomainInfo vardom = info.getVarDomain();
		ValueListInfo dom= info.getValueList();//OLD DTD Style
		Domain domain=null;
		if (vardom != null || dom !=null) {
			domain = new DefaultDomain(this.getSolver());
		}
		if (vardom != null && domain !=null) {
			if (domainAdapter != null) domainAdapter.adapt(vardom,domain);
			
		} else if (dom != null && domain !=null ) {
			adapt(dom,domain);
		}
		element.addDomain(domain);
		
		StateInfo st = info.getState();
		if (st != null) {
			State state = new DefaultState(this.getSolver());
			if (stateAdapter != null) stateAdapter.adapt(st,state);
			element.setState(state);
		}
	}
	
	
	/**
	 * @return Returns the domainAdapter.
	 */
	public synchronized DomainAdapter getDomainAdapter() {
		return domainAdapter;
	}
	/**
	 * @param domainAdapter The domainAdapter to set.
	 */
	public synchronized void setDomainAdapter(DomainAdapter domainAdapter) {
		this.domainAdapter = domainAdapter;
	}
	/**
	 * @return Returns the stateAdapter.
	 */
	public synchronized StateAdapter getStateAdapter() {
		return stateAdapter;
	}
	/**
	 * @param stateAdapter The stateAdapter to set.
	 */
	public synchronized void setStateAdapter(StateAdapter stateAdapter) {
		this.stateAdapter = stateAdapter;
	}
}
