/*
 * Created on 28 avr. 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package fr.inria.oadymppac.utils;

import org.apache.log4j.Logger;

/**
 * @author raf
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class IntIntervalArray {
	public static final Logger logger = Logger.getLogger(IntIntervalArray.class);
	public static final int NONE=DynamicIntArray.NONE;
	
	protected int minimum=0;
	protected int maximum=0;
	protected int size=0;
	
	protected DynamicIntArray intervals;
	
	private int[] temp = new int[2];
	
	/**
	 *a a new range of values to the interval
	 * @param from : la borne min
	 * @param to
	 */
	public synchronized void add(int from, int to) {
		if (from > to) 
			add(to, from);
		else {
			
			if (intervals == null) {
				//if (looger.isDebugEnabled()) logger.info("Creating contents and inserting first interval");
				intervals = new DynamicIntArray();
				intervals.set(0,from);
				intervals.set(1,to);
				setMin(from);
				setMax(to);
				setSize(to-from+1);			
			} else if (intervals.last() == 0) {
				//if (looger.isDebugEnabled()) logger.info("Inserting first interval in a cleared content");
				intervals.set(0,from);
				intervals.set(1,to);
				setMin(from);
				setMax(to);
				setSize(to-from+1);
			} else
				addInsert(from, to);
		}
	}
		
	
	protected synchronized void addInsert(int from, int to) {
		int last = intervals.last();
		int after = findIntervalAfter(0,from); // find the interval after from
		int before = findIntervalBefore((after == -1 ? 0 : after), to); //find the interval before to
		//if (looger.isDebugEnabled()) logger.info("AFTER:"+after+" BEFORE:"+before);
		int minAfter = intervals.get((after ==-1 ? 0 : after));
		int maxAfter = intervals.get((after == -1 ? 1 : after+1));
		int minBefore = intervals.get((before == -1 ? last-1 : before));
		int maxBefore = intervals.get((before == -1 ? last : before+1));
		//if (looger.isDebugEnabled()) logger.info("MIN AFT:"+minAfter+ " MAX AFT:"+ maxAfter+ " MIN BFR:"+minBefore + " MAX BFR:"+maxBefore);
		if ( from <= minimum && to >= maximum ) {
			//if (looger.isDebugEnabled()) logger.info("Added interval cover completely the current domain");
			after =(after == -1 ? 0 : after);
			before = (before == -1 ? 0 : before);
			if (after < before) {
				swap(after,before);
			}
			//if (looger.isDebugEnabled()) logger.info("Cleaning "+after+":"+(before+1));
			intervals.clear(after, before + 1);
			intervals.set(after, from);
			intervals.set(after+1, to);
			setMin(from);
			setMax(to);
			setSize(to-from+1);
		} else if ( before == -1  && after !=-1 && to <= minAfter-1 ) {
			//if (looger.isDebugEnabled()) logger.info("Prepend interval without merge");
			temp[0] = from;
			temp[1] = to;
			intervals.insert(after  , temp);
			incSize(to - from + 1);
			setMin(from);
		} else if ( after == -1  && before != -1 && from >= maxBefore+1 ) {
			//if (looger.isDebugEnabled()) logger.info("Postpend interval without merge");
			temp[0] = from;
			temp[1] = to;
			intervals.add(temp);
			incSize(to - from + 1);
			setMax(to);
		} else if ( before != -1 && after != -1 ) {
			if (from > maxAfter + 1 && to < minBefore-1  && after < before ) {
				//if (looger.isDebugEnabled()) logger.info("Inserting  new interval" );
				temp[0] = from;
				temp[1] = to;
				intervals.insert(before  , temp);
				incSize(to - from + 1);
			} else	if (from > maxBefore + 1 && to < minAfter-1  && after > before ) {
					//if (looger.isDebugEnabled()) logger.info("Inserting  new interval" );
					temp[0] = from;
					temp[1] = to;
					intervals.insert(after  , temp);
					incSize(to - from + 1);
			} else if (from >= minAfter && from <= maxAfter+1  && to >= minBefore-1 && to <= maxBefore) {
				//if (looger.isDebugEnabled()) logger.info("Complete overlapping of existing intervals" );
				intervals.clear(after+1, before + 1);
				intervals.set(after+1, maxBefore);
				setSize(0);
				updateSize(0, intervals.last());
			} else if (from >= minAfter  && from <= maxAfter+1  && to >= maxBefore) {
				//if (looger.isDebugEnabled()) logger.info("Complete overlapping of existing intervals with BEFORE MAX UPDATE" );
				intervals.clear(after+1, before + 1);
				intervals.set(after+1, to);
				setSize(0);
				updateSize(0, intervals.last());
				setMax(maximum > to ? maximum : to);
			} else  if ( from <= maxAfter  && to >= minBefore - 1 && to <= maxBefore) {
				//if (looger.isDebugEnabled()) logger.info("Complete overlapping of existing intervals with BEFORE MIN UPDATE" );
				intervals.clear(after, before + 1);
				intervals.set(after, from);
				intervals.set(after+1, maxBefore);
				setSize(0);
				updateSize(0, intervals.last());
				setMin(minimum < from ? minimum : from);
			}
		}
	}
	
	
	public synchronized void remove(int from, int to) {
		if (from > to) 
			remove(to, from);
		else {
			
			if (intervals == null || intervals.last() == 0 ) {
				//if (looger.isDebugEnabled()) logger.info("Empty domain, nothing to remove");
			} else
				removeInside(from, to);
		}
	}
		
	
	protected synchronized void removeInside(int from, int to) {
		if ( from > maximum || to < minimum) {
			//if (looger.isDebugEnabled()) logger.info("Removing out of bounds");
		} else {
			int last = intervals.last();
			int after = findIntervalAfter(0,from); // find the interval after from
			int before = findIntervalAfter((after == -1 ? 0 : after), to); //find the interval before to
			//if (looger.isDebugEnabled()) logger.info("AFTER:"+after+" BEFORE:"+before);
			int minAfter = intervals.get((after ==-1 ? 0 : after));
			int maxAfter = intervals.get((after == -1 ? 1 : after+1));
			int minBefore = intervals.get((before == -1 ? last-1 : before));
			int maxBefore = intervals.get((before == -1 ? last : before+1));
			//if (looger.isDebugEnabled()) logger.info("MIN AFT:"+minAfter+ " MAX AFT:"+ maxAfter+ " MIN BFR:"+minBefore + " MAX BFR:"+maxBefore);
			if ( before != -1 && after != -1 ) {
				if (from > minAfter && from <= maxAfter  && to >= minBefore && to < maxBefore && before != after) {
					//if (looger.isDebugEnabled()) logger.info("Complete overlapping of existing intervals, updating min and max" );
					intervals.clear(after+1, before);
					intervals.set(after+1, from-1);
					intervals.set(before, to+1);
					setSize(0);
					updateSize(0, intervals.last());
				} else if (from > minAfter && from < maxAfter  && to > minBefore && to < maxBefore && before == after) {
					//if (looger.isDebugEnabled()) logger.info("Removing inside same interval" );
					temp[0]= from - 1;
					temp[1] = to + 1;
					intervals.insert(after+1, temp);
					setSize(0);
					updateSize(0, intervals.last());
				} else  if ( from <= minAfter  && to <= minBefore  ) {
					//if (looger.isDebugEnabled()) logger.info("Removing updating min" );
					if (before >= after) intervals.clear(after, before - 1);
					intervals.set(before,to+1);
					intervals.set(before+1, (to + 1 > maxBefore ? to + 1: maxBefore));
					setSize(0);
					updateSize(0, intervals.last());
				} else  if ( from < minAfter  && to > minBefore && to < maxBefore ) {
					//if (looger.isDebugEnabled()) logger.info("Removing updating min2" );
					intervals.clear(after, before-1);
					intervals.set(before,to+1);
					setSize(0);
					updateSize(0, intervals.last());
					setMin(to+1);
				} else if ( from >= minBefore && to >= maxBefore) {
					//if (looger.isDebugEnabled()) logger.info("Removing updating max" );
					intervals.clear(after+1, before+1);
					intervals.set(after+1, from - 1);
					setSize(0);
					updateSize(0, intervals.last());		
				} 
			}
		}
	}
	

	private void swap(int v1, int v2) {
		int swp = v1;
		v1 = v2;
		v2 = swp;
	}

	/**
	 * find the interval just after the value, i.e.
	 * first interval with an lower bound superior
	 * to value 
	 * @param start The index to start the search
	 * @param value the value to search
	 * @return the start index of the interval
	 */
	protected int findIntervalAfter(int start, int value) {
		int last = intervals.last();
		int result = start;
		int inf,sup;
		while(result <= last) {
			inf=intervals.get(result);
			sup=intervals.get(result+1);
			if (inf != NONE && sup != NONE && inf-1 <= value && sup+1 >= value) {
				return result;
			} else if (inf != NONE  &&  value <= inf -1) {
				return result;
			} else {
				result+=2;
			}
		}
		return -1;
	}
	/**
	 * find the interval just before the value, i.e.
	 * first interval with an lower bound superior
	 * to value 
	 * @param start The index to start the search
	 * @param value the value to search
	 * @return the start index of the interval
	 */	
	protected int findIntervalBefore(int start, int value) {
		int last = intervals.last();
		int result = last-1;
		int inf, sup;
		while(result >= 0) {
			inf=intervals.get(result);
			sup=intervals.get(result+1);
			//if (looger.isDebugEnabled()) logger.info("result="+result+" sup="+ sup + " value="+value);
			if (inf != NONE && sup != NONE && inf-1 <= value && sup+1 >= value) {
				return result;
			} else if (sup != NONE  &&  sup  < value ) {
				return result;
			} else {
				result-=2;
			}
		}
		return -1;
	}
	/**
	 * @return Returns the intervals.
	 */
	public synchronized DynamicIntArray getIntervals() {
		return intervals;
	}
	/**
	 * @param intervals The intervals to set.
	 */
	public synchronized void setIntervals(DynamicIntArray intervals) {
		this.intervals = intervals;
	}
	/**
	 * @return Returns the max.
	 */
	public synchronized int getMax() {
		return maximum;
	}
	/**
	 * @param max The max to set.
	 */
	public synchronized void setMax(int max) {
		this.maximum = max;
	}
	/**
	 * @return Returns the min.
	 */
	public synchronized int getMin() {
		return minimum;
	}
	/**
	 * @param min The min to set.
	 */
	public synchronized void setMin(int min) {
		this.minimum = min;
	}
	/**
	 * @return Returns the size.
	 */
	public synchronized int getSize() {
		return size;
	}
	/**
	 * @param size The size to set.
	 */
	public synchronized void setSize(int size) {
		this.size = size;
	}
	
	protected synchronized void incSize(int sz) {
		this.size += sz;
	}
	
	public String toString() {
		if (intervals == null) {
			return "EMPTY" ;
		} else {
			StringBuffer buffer =new StringBuffer("IntIntervalArray@");
			buffer.append(Integer.toHexString(hashCode()));
			buffer.append("< min="+minimum);
			buffer.append(", max="+maximum);
			buffer.append(", size="+size);
			buffer.append(", last="+intervals.last());
			buffer.append(", count="+intervals.count());
			buffer.append(", ");
			buffer.append(intervals.toStringContent());
			buffer.append(">");
			return buffer.toString();
		}
	}
	
	public void clear() {
		intervals.clear();
		setMin(NONE);
		setMax(NONE);
		setSize(0);
	}
	
	protected void updateSize(int start , int end) {
		int from;
		int to;
		for (int i=start; i < end; i+=2 ) {
			from =intervals.get(i);
			to = intervals.get(i+1);
			if (from != NONE && to !=NONE) incSize(to-from +1);
		}
	}	
	/**
	 * Return a new array initalized with the 
	 * current content of the IntIntervalArray 
	 * @return the created array
	 */
	public int[] toArray() {
		return intervals.toArray();
	}
	
	/**
	 * Clone the Array (i.e. build a copy) 
	 * @see java.lang.Object#clone()
	 * The content is also cloned
	 */
	public final Object clone() throws CloneNotSupportedException {
		IntIntervalArray clone = new IntIntervalArray();
		DynamicIntArray clonedValues = new DynamicIntArray(intervals.getValues());
		clone.setIntervals(clonedValues);
		clone.setMin(this.minimum);
		clone.setMax(this.maximum);
		clone.setSize(this.size);
		return clone;
	}
	/**
	 * @return
	 */
	public int[] getValues() {
		return intervals.getValues();
	}
}
