/* 
 * ### Copyright (C) 2001-2003 Michael Fuchs ###
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *      
 * Author: Michael Fuchs
 * E-Mail: mfuchs@unico-consulting.com
 *
 * RCS Information:
 * ---------------
 * Id.........: $Id: DirectoryOption.java, v 1.1.1.1 2003/10/21 19:19:15 cvs Exp $
 * Author.....: $Author: cvs $
 * Date.......: $Date: 2003/10/21 19:19:15 $
 * Revision...: $Revision: 1.1.1.1 $
 * State......: $State: Exp $
 */
package com.mf.option;

import java.io.File;



/**
 * Describe class <code>DirectoryOption</code> here.
 *
 * @author <a href="mailto:mfuchs@unico-consulting.com">Michael Fuchs</a>
 * @version 1.0
 */
public class DirectoryOption extends Option {

    /**
     * Describe variable <code>isExisting</code> here.
     *
     */
    private boolean isExisting = false;
    
    private boolean createPath = false;

    /**
     * Creates a new <code>DirectoryOption</code> instance.
     *
     */
    public DirectoryOption() {
        super();
        hasArgument(true);
    }

    public DirectoryOption(String longName) {
        super(longName);
        hasArgument(true);
    }

    /**
     * Creates a new <code>DirectoryOption</code> instance.
     *
     * @param longName a <code>String</code> value
     * @param shortName a <code>String</code> value
     */
    public DirectoryOption(String longName, String shortName) {
        super(longName, shortName);
        hasArgument(true);
    }

    /**
     * Describe <code>isExisting</code> method here.
     *
     * @param value a <code>boolean</code> value
     */
    public void isExisting(boolean value) {
        isExisting = value;
    }

    public void setCreatePath(boolean createPath) {
        this.createPath = createPath;
    }
    
    /**
     * Describe <code>checkArgument</code> method here.
     *
     * @param arg a <code>String</code> value
     * @return a <code>boolean</code> value
     */
    protected boolean checkArgument(String arg) {

        File file = new File(arg);
            
        System.out.println("1: " + file.getAbsolutePath());

        if (file.exists() == false && createPath == true) {
            System.out.println(file.getAbsolutePath());
            file.mkdirs();
        }

        if (isExisting == true && file.exists() == false) {
            return false;
        } // end of if (path.exists() == false)
    
        if (file.exists() == true && file.isDirectory() == false) {
            return false;
        } // end of if (path.exists() == false)

        return true;
    }
}
/*
 * $Log: DirectoryOption.java, v $
 * Revision 1.1.1.1  2003/10/21 19:19:15  cvs
 * Getopts library.
 *
 * Revision 1.1  2003/08/13 18:39:47  mfuchs
 * Option
 *
 * Revision 1.1  2003/08/12 19:28:10  mfuchs
 * log4j properties files for differnet logging levels.
 *
 */
