/* 
 * ### Copyright (C) 2001-2003 Michael Fuchs ###
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *	
 * Author: Michael Fuchs
 * E-Mail: mfuchs@unico-consulting.com
 *
 * RCS Information:
 * ---------------
 * Id.........: $Id: FileOption.java,v 1.1.1.1 2003/10/21 19:19:15 cvs Exp $
 * Author.....: $Author: cvs $
 * Date.......: $Date: 2003/10/21 19:19:15 $
 * Revision...: $Revision: 1.1.1.1 $
 * State......: $State: Exp $
 */
package com.mf.option;

import java.io.File;



public class FileOption extends Option {

    private boolean isExisting = false;
    
    public FileOption() {
	super();
	hasArgument(true);
    }

    public FileOption(String longName) {
	super(longName);
	hasArgument(true);
    }

    public FileOption(String longName, String shortName) {
	super(longName,shortName);
	hasArgument(true);
    }

    public void isExisting(boolean value) {
        isExisting = value;
    }
    
    protected boolean checkArgument(String arg) 
    {
        File file = new File(arg);
            
        if (isExisting == true && file.exists() == false) {
            return false;
        }
    
        if (file.exists() == true && file.isFile() == false) {
            return false;
        }

	return true;
    }
}
/*
 * $Log: FileOption.java,v $
 * Revision 1.1.1.1  2003/10/21 19:19:15  cvs
 * Getopts library.
 *
 * Revision 1.1  2003/08/13 18:39:47  mfuchs
 * Option
 *
 * Revision 1.1  2003/08/12 19:28:10  mfuchs
 * log4j properties files for differnet logging levels.
 *
 */
