/* 
 * ### Copyright (C) 2001-2003 Michael Fuchs ###
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330, 
 * Boston, MA 02111-1307, USA.
 *      
 * Author: Michael Fuchs
 * E-Mail: mfuchs@unico-consulting.com
 *
 * RCS Information:
 * ---------------
 * Id.........: $Id: SelectOption.java, v 1.1.1.1 2003/10/21 19:19:15 cvs Exp $
 * Author.....: $Author: cvs $
 * Date.......: $Date: 2003/10/21 19:19:15 $
 * Revision...: $Revision: 1.1.1.1 $
 * State......: $State: Exp $
 */
package com.mf.option;

/**
 * Describe class <code>SelectOption</code> here.
 *
 * @author <a href="mailto:mfuchs@unico-consulting.com">Michael Fuchs</a>
 * @version 1.0
 */
public class SelectOption extends Option {
    /**
     * Describe variable <code>m_list</code> here.
     *
     */
    private String[] m_list;
    
    public SelectOption() {
        super();
        hasArgument(true);
    }

    /**
     * Creates a new <code>SelectOption</code> instance.
     *
     * @param longName a <code>String</code> value
     * @param shortName a <code>String</code> value
     */
    public SelectOption(String longName, String shortName) {
        super(longName, shortName);
        hasArgument(true);
    }

    /**
     * Describe <code>setList</code> method here.
     *
     * @param list a <code>String[]</code> value
     */
    public void setList(String[] list) {
        m_list = list;
    }

    /**
     * Describe <code>getListAsString</code> method here.
     *
     * @return a <code>String</code> value
     */
    public String getListAsString() {
        String buffer = "";
        
        for (int i = 0; i<m_list.length; i++) {

            buffer += m_list[i];
            
            if (i < m_list.length-1)
                buffer += ", ";
        }
        
        return buffer;
    }


    /**
     * Describe <code>checkArgument</code> method here.
     *
     * @param arg a <code>String</code> value
     * @return a <code>boolean</code> value
     */
    protected boolean checkArgument(String arg) {
        for (int i = 0; i<m_list.length; i++) {

            if (arg.equals(m_list[i]))
                return true;

        } // end of for ()

        return false;
    }
    
}
/*
 * $Log: SelectOption.java, v $
 * Revision 1.1.1.1  2003/10/21 19:19:15  cvs
 * Getopts library.
 *
 * Revision 1.1  2003/08/13 18:39:47  mfuchs
 * Option
 *
 * Revision 1.1  2003/08/12 19:28:10  mfuchs
 * log4j properties files for differnet logging levels.
 *
 */
