<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  
  <xsl:output method="xml" 
    omit-xml-declaration="yes"
    encoding="iso-8859-1" 
    indent="yes"/>

  <xsl:template match="meta">
    <xsl:apply-templates select="deprecated"/>
    <variablelist>
      <title><xsl:value-of select="title"/></title>
      <xsl:apply-templates select="entry"/>
    </variablelist>
  </xsl:template>

  <xsl:template match="deprecated">
    <warning>
      <title><xsl:value-of select="label"/></title>
      <xsl:copy-of select="description/para"/>
    </warning>
  </xsl:template>

  <xsl:template match="entry">
    <varlistentry>
      <xsl:apply-templates/>
    </varlistentry>
  </xsl:template>

  <xsl:template match="label">
    <term><xsl:value-of select="."/></term>
  </xsl:template>

  <xsl:template match="description">
    <listitem>
      <xsl:copy-of select="para"/>
    </listitem>
  </xsl:template>

</xsl:stylesheet>