<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:UML="org.omg/standards/UML"
  version="1.0">

  <xsl:output 
    method="xml"
    version="1.0"
    indent="yes"
    encoding="UTF-8"/>

  <xsl:template match="/">
    <XMI xmlns:UML="org.omg/standards/UML" verified="false" timestamp="" xmi.version="1.2">
      <XMI.header>
        <XMI.documentation>
          <XMI.exporter>umbrello uml modeller http://uml.sf.net</XMI.exporter>
          <XMI.exporterVersion>1.1</XMI.exporterVersion>
        </XMI.documentation>
        <XMI.model xmi.name="dbdoclet" href="Reference.xmi"/>
        <XMI.metamodel xmi.name="UML" href="UML.xml" xmi.version="1.3"/>
      </XMI.header>
      
      <XMI.content>
        <xsl:element name="docsettings">
          <xsl:attribute name="viewid">1</xsl:attribute>
          <xsl:attribute name="documentation"></xsl:attribute>
          <xsl:attribute name="uniqueid">
            <xsl:value-of select="count(class) + count(field) + count(method)"/>
          </xsl:attribute>
        </xsl:element>
        <umlobjects>
          <xsl:apply-templates select="/dbdoclet-data/class" mode="umlobject"/>
        </umlobjects>
        <diagrams>
          <diagram snapgrid="0" showattsig="1" fillcolor="#ffffc0" showgrid="0" showopsig="1" usefillcolor="1" snapx="10" snapy="10" showatts="1" xmi.id="1" documentation="" type="402" showops="1" showpackage="0" name="Klassendiagramm" localid="30000" showstereotype="0" showscope="1" font="Helvetica,12,-1,5,50,0,0,0,0,0" linecolor="#ff0000">
            <widgets/>
            <messages/>
            <associations/>
          </diagram>
        </diagrams>
        <listview>
          <listitem open="1" type="800" id="-1" label="Sichten" >
            <listitem open="1" type="802" id="-1" label="Anwendungsfallsicht"/>
            <listitem open="1" type="801" id="-1" label="Logische Sicht">
              <xsl:apply-templates select="/dbdoclet-data/class" mode="listitem"/>
              <listitem open="0" type="807" id="1" label="Klassendiagramm"/>
            </listitem>
          </listitem>
        </listview>
      </XMI.content>
    </XMI>
  </xsl:template>

  <xsl:template match="/dbdoclet-data/class" mode="umlobject">
    <xsl:element name="UML:Class">
      <xsl:attribute name="stereotype"></xsl:attribute>
      <xsl:attribute name="package"><xsl:value-of select="package"/></xsl:attribute>
      <xsl:attribute name="xmi.id"><xsl:number level="any" count="class|field|method"/></xsl:attribute>
      <xsl:attribute name="abstract"></xsl:attribute>
      <xsl:attribute name="documentation"></xsl:attribute>
      <xsl:attribute name="name"><xsl:value-of select="name"/></xsl:attribute>
      <xsl:attribute name="static">0</xsl:attribute>
      <xsl:attribute name="scope">200</xsl:attribute>
      <xsl:apply-templates select="fields/visibility/field"/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="/dbdoclet-data/class" mode="listitem">
    <xsl:element name="listitem">
      <xsl:attribute name="open">1</xsl:attribute>
      <xsl:attribute name="type">813</xsl:attribute>
      <xsl:attribute name="id"><xsl:number level="any" count="class|field|method"/></xsl:attribute>
      <xsl:attribute name="label"><xsl:value-of select="name"/></xsl:attribute>
    </xsl:element>
  </xsl:template>

  <xsl:template match="field">
    <xsl:element name="UML:Attribute">
      <xsl:attribute name="stereotype"></xsl:attribute>
      <xsl:attribute name="package"><xsl:value-of select="package"/></xsl:attribute>
      <xsl:attribute name="xmi.id"><xsl:number level="any" count="class|field|method"/></xsl:attribute>
      <xsl:attribute name="value"></xsl:attribute>
      <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
      <xsl:attribute name="abstract"></xsl:attribute>
      <xsl:attribute name="documentation"></xsl:attribute>
      <xsl:attribute name="name"><xsl:value-of select="name"/></xsl:attribute>
      <xsl:attribute name="static">0</xsl:attribute>
      <xsl:attribute name="scope">200</xsl:attribute>
    </xsl:element>
  </xsl:template>

</xsl:stylesheet>
